// App-Specific Configuration

// Constant Properties - Make changes here
app.constant('appConstants', {

    app: {
        name: 'EventHub',
        tagLine: '',
        bundleId: 'com.eventeye.campus17', //events
        buildId: 6,
        preferredLanguage: 'en-US_elbit',             // 'en-US',     'nb-NO',    'sv-SE'
        preferredLanguageShort:'en',            // 'en',        'nb',       'sv'
        helpDeskUrl: 'https://eventeye.freshdesk.com/support/tickets/new',
        flagContentEmail: 'support@eventeye.co',
        appId: '1069', // Container 1085 / DEV 1023
        eventId: '',
        defaultAuthorizedState: 'tabs.feed',
        defaultProfileImage: 'img/defaultProfileImage.png',
        defaultLogoImage: 'img/ico_app_title.png',
        attendAllSessions: false,
        isContainerApp: false,
        eventSplashScreenDelay: 3500,

        integrations: {
            agendaBaseURL: 'https://egencia.qondor.com/Program/Display?'
        },

        analytics: {
            activated: true
        },
        
        participantConfig: {

            editProfile: {
                updateProfileReminderDays: 45,
                email: false,
                linkedIn: false,
                mobile: false,
                twitter: true,
                description: true
            },
            'participantList': {
                searchCompany: true,
                searchPosition: true
            }
        },
        speakerConfig: {
            'speakerList': {
                company: true,
                position: true,
                searchCompany: true,
                searchPosition: true
            }
        },
        debugging: {
            enableDebugLogging: false,
            localCacheDebugging: false,
            standardTimeoutDelay: 0,
            useCustomToken: false,
            customToken: ""
        }
        
    },

    auth: {
        protectAllRoutes: true,
        redirectKey: 'auth:redirect',
        loginState: 'auth.login',
        demoLoginEmail: 'reviewer@eventeye.no',
    },

    api: {
        version: '1.2.6',
        production: true,
        urlDev: 'http://ee-mobile-api-dev.azurewebsites.net/api',
        urlProd: 'https://mobile-api.eventeye.co/api'
    },
    dataModel: 17,
    push: {
        gcmProjectId: '305027291906', // config.xml - DEBUG app 1061: 231361585499
        ios: {
            badge: 'true',
            sound: 'true',
            alert: 'true'
        },
    }

});


// Dynamic Properties - Do not change
app.service('appConfiguration', function (appConstants) {
    this.apiUrl = (appConstants.api.production === true) ? (appConstants.api.urlProd + "/v" + appConstants.api.version + "/") : (appConstants.api.urlDev + "/v" + appConstants.api.version + "/");
    this.apiUrlNoVersion = (appConstants.api.production === true) ? (appConstants.api.urlProd + "/") : (appConstants.api.urlDev + "/");

    this.localStorageKeys = {};
    this.localStorageKeys.eventServiceKey = ("eventService_" + appConstants.app.bundleId + "_" + appConstants.dataModel);
    this.localStorageKeys.stashName = function (eventId) {
        return ("stash_" + appConstants.app.bundleId + "_" + eventId + "_" + appConstants.dataModel);
    }
    this.localStorageKeys.IMAGE_STORAGE_KEY = ("imageStorageKey" + appConstants.app.bundleId + "_" + appConstants.dataModel);
    this.localStorageKeys.lastSyncDateKey = ("lastSyncDateKey_" + appConstants.app.bundleId + "_" + appConstants.dataModel);
    this.localStorageKeys.buildId = ("buildId_" + appConstants.app.bundleId);

    this.localStorageKeys.auth = {};
    this.localStorageKeys.auth.tokenKey = ("auth:token_" + appConstants.app.bundleId + "_" + appConstants.dataModel);
    this.localStorageKeys.auth.lastUsedEmailKey = ("auth:lastUsedEmail_" + appConstants.app.bundleId + "_" + appConstants.dataModel);

    this.localStorageKeys.push = {};
    this.localStorageKeys.push.registrationIdKey = ("push:registrationId_" + appConstants.app.bundleId);
    
    this.localStorageKeys.modules = {};
    this.localStorageKeys.modules.openQuestionLastSync = ("openQuestion:lastSync_" + appConstants.app.bundleId + "_" + appConstants.dataModel); // Add question ID at end when using

    this.privacyPolicyUrl = "";
    if (appConstants.app.preferredLanguage == "nb-NO") {
        this.privacyPolicyUrl = "http://eventeye.co/resources/personvern.html";
    } else {
        this.privacyPolicyUrl = "http://eventeye.co/resources/privacypolicy.html";
    }
});

// Changeable values
app.value('appValues', {
    verificationToken: ''
});