controllers.controller('AboutAppCtrl', ['$scope', '$state', '$http', 'AnalyticsService', 'appConstants', 'AppService', '$ionicScrollDelegate', '$translate', '$ionicActionSheet', '$cordovaEmailComposer', 'datacontext', 'session', 'ObjectService', '$ionicLoading', '$ionicPopup', '$ionicHistory', function($scope, $state, $http, AnalyticsService, appConstants, AppService, $ionicScrollDelegate, $translate, $ionicActionSheet, $cordovaEmailComposer, datacontext, session, ObjectService, $ionicLoading, $ionicPopup, $ionicHistory) {


    $scope.$on("$ionicView.beforeEnter", function() {
        // If navigation history is empty (ie. browser refresh) --> reset state to parent tab
        if ($ionicHistory.viewHistory().currentView.backViewId == null) {
            $ionicHistory.nextViewOptions({
                disableAnimate: true,
                disableBack: true
            });
            $state.go("tabs.menu");
        }       

        $scope.formSuccessfullySent = false;
    });

    $scope.$on('$ionicView.enter', function() {

        

        // Analytics
        if (!ionic.Platform.isWebView()) {
            trackProfileView();
        } else {
            AnalyticsService.startTimer("About App State Open");
        }

        /* participantEntity = datacontext.getCachedProfile(session.getLoggedInParticipantId());

        var participant = ObjectService.getSimpleObject(e.apiContentTypes.Profile, participantEntity);

        $scope.firstName = ($scope.firstName != "" && participant.firstName) ? participant.firstName : ""; 
        $scope.lastName  = ($scope.lastName != "" && participant.lastName) ? participant.lastName : ""; 
        $scope.email     = ($scope.email != "" && participant.email) ? participant.email : "";  */

        $ionicScrollDelegate.resize()


    });

    $scope.$on('$ionicView.leave', function(e) {
        if (ionic.Platform.isWebView()) {
            trackProfileView();
        }
    });

    function trackProfileView() {
        var eventProperties = {
            "State Name": "AboutApp"
        };
        AnalyticsService.trackEvent("About App State Open", eventProperties);
    }

    $scope.appSupport = function() {
        window.open(appConstants.app.helpDeskUrl, '_blank');
    }

    $scope.submitForm = function (firstName, lastName, company, email, phone) {
        var confirmPopup = $ionicPopup.confirm({
            title: $translate.instant('NAVIGATION.ABOUT_APP.PROMPTS.DISCLAIMER.TITLE'),
            template: $translate.instant('NAVIGATION.ABOUT_APP.PROMPTS.DISCLAIMER.BODY'),
            okText: $translate.instant('NAVIGATION.ABOUT_APP.PROMPTS.DISCLAIMER.OK_BUTTON'),
            cancelText: $translate.instant('NAVIGATION.ABOUT_APP.PROMPTS.DISCLAIMER.CANCEL_BUTTON')
        });

        confirmPopup.then(function (res) {
            if (res) {
                // Continue
                $ionicLoading.show({
                    template: '<ion-spinner></ion-spinner>'
                });
                try {
                    AnalyticsService.trackEvent("About App Contact Form Sent", {});
                } catch (e) {

                }

                AppService.hasConnection().success(function () {


                    // Submit via Zapier


                    // Reimplement to send via our API

                    var leadData = {
                        data: {
                            first_name: firstName,
                            last_name: lastName, // $scope.lastName,
                            organization_name: company,
                            email: email,
                            phone: phone,
                            description: ("Inbound from participant in AppId: " + appConstants.app.appId),
                            source_id: 332661
                        }
                    };

                    $http.post('https://hooks.zapier.com/hooks/catch/1861431/t7fqv0/', leadData)
                        //$http.post('http://requestb.in/1dw8jll1', leadData)
                        .success(function (data, status, headers, config) {
                            // Hide spinner and let user know the email has been sent
                            // Clear form

                            $scope.formSuccessfullySent = true;

                            $ionicLoading.hide();

                            $translate.onReady().then(function () {
                                var alertPopup = $ionicPopup.show({
                                    title: $translate.instant('NAVIGATION.ABOUT_APP.PROMPTS.FORM_SENT.TITLE'),
                                    template: $translate.instant('NAVIGATION.ABOUT_APP.PROMPTS.FORM_SENT.BODY'),
                                    buttons: [{
                                        text: $translate.instant('NAVIGATION.ABOUT_APP.PROMPTS.FORM_SENT.OK_BUTTON'),
                                        type: 'button-positive'
                                    }]
                                });
                            });

                            /*
                                                var showAlert = function() {
                                                    var alertPopup = $ionicPopup.alert({
                                                        title: 'Sent',
                                                        template: 'Your details has been sent and we will be in touch with you as soon as possible!'
                                                    });
                                                };
    
                                                showAlert();
                            */

                        }).error(function (data, status, headers, config) {
                            $ionicLoading.hide();
                            $scope.openMail(firstName, lastName, company, email, phone);
                            // Show error and refer to website / open website in-app upon OK
                            // OR do as below: open prepopulated email with field values to hello@eventeye.no
                        });


                    // If success --> Let user know

                    // If failure --> Open pre-populated email with field values to hello@eventeye.no

                }).error(function (err) {
                    $ionicLoading.hide();
                    // Open email
                    $scope.openMail(firstName, lastName, company, email, phone);
                });
            }
        })
        return;




    }

    // Triggered on a button click, or some other target
    $scope.showHelpMenu = function() {
        $translate.onReady().then(function() {

            // Show the action sheet
            var hideSheet = $ionicActionSheet.show({
                buttons: [{
                    text: $translate.instant('AUTH.SIGNIN_VERIFICATION.SUPPORT.OPTIONS.FAQ')
                }, {
                    text: $translate.instant('AUTH.SIGNIN_VERIFICATION.SUPPORT.OPTIONS.CONTACT_SUPPORT')
                }],
                titleText: $translate.instant('AUTH.SIGNIN_VERIFICATION.SUPPORT.ACTION_MENU_TITLE'),
                cancelText: $translate.instant('AUTH.SIGNIN_VERIFICATION.SUPPORT.OPTIONS.CANCEL'),
                cancel: function() {
                    // add cancel code..
                },
                buttonClicked: function(index) {
                    switch (index) {
                        case 0:
                            {
                                // FAQ: 
                                window.open('https://eventeye.freshdesk.com/support/solutions/folders/35000091301', '_blank');
                                break;
                            }
                        case 1:
                            {
                                // Contact Support
                                window.open(appConstants.app.helpDeskUrl, '_blank');
                                break;
                            }
                    }
                    return true;
                }
            });
        });

    };

	$scope.openMail = function(firstName, lastName, company, email, phone) {
        
        var newMail = {
            to: "hello@eventeye.co",
            subject: "Please contact me regarding an event app",
            body: "Hi, <br /> I tried to submit the form in the event app but it wouldn't send because I was offline at the time. Please get in touch with me, here are my details: <br />Name: " + firstName + " " + lastName + "<br />Company: " + company + "<br />Email: " + email + "<br />Telephone: " + phone + "<br/><br/> Thanks!"
        };

        $cordovaEmailComposer.open(newMail).then(null, function() {
            // User cancelled email
        });
        //}, function () {
        //   $log.debug("email not available");
        //});
    };
    



}]);