controllers.controller('AgendaCtrl', ['$scope', '$state', 'datacontext', 'appConstants', '$log', 'ObjectService', '_', '$ionicListDelegate', '$ionicModal', '$ionicHistory', '$ionicScrollDelegate', 'eventService', function ($scope, $state, datacontext, appConstants, $log, ObjectService, _, $ionicListDelegate, $ionicModal, $ionicHistory, $ionicScrollDelegate, eventService) {
    
    var allDays = [];
    var datePickerIndex = 0;
    $scope.agendaLoadedForEvent = 0;
    $scope.prevDate = "";
    $scope.currentDate = {};
    $scope.nextDate = "";
    $scope.agendaItems = [];
    $scope.tracks = [];
    $scope.selectedTracks = {};
    $scope.emptyAgenda = true;
    var currentEvent = [];
    

    $scope.agendaMode = e.agendaModes.Full;

    $scope.$on('$ionicView.enter', function(err) {
        checkEvent(); 
        loadAgenda();
        gotoToday();

    });

    function checkEvent() {
        
        if ($scope.agendaLoadedForEvent != eventService.getId()) {
            var allDays = [];
            var datePickerIndex = 0;
            var agendaLoadedForEvent = 0;
            $scope.prevDate = "";
            $scope.currentDate = {};
            $scope.nextDate = "";
            $scope.agendaItems = [];
            $scope.tracks = [];
            $scope.selectedTracks = {};
            $scope.emptyAgenda = true;
            $scope.agendaMode = e.agendaModes.Full;
            currentEvent = ObjectService.getSimpleObject(e.apiContentTypes.Event, datacontext.getCachedEventInformation(eventService.getId()));
        }
    }

    function loadAgenda() {

        $scope.agendaLoadedForEvent = eventService.getId();
        

        allSessions = ObjectService.getSimpleObjectArray(e.apiContentTypes.ScheduleItem, datacontext.getCachedScheduleItems());
        // Get array of all sessions with relevant data
        var _allSessions = [];

        for (i = 0; i < allSessions.length; i++) {
            var session = allSessions[i];
     
            var detailedSession = {};

            var allSpeakersForSession = ObjectService.getSimpleObjectArray(e.apiContentTypes.Speaker, datacontext.getCachedSpeakers(session.speakerIds));

            var _speakers = {};

            if (allSpeakersForSession.length <= 3) {
                _speakers.speakers = allSpeakersForSession;
            } else {
                _speakers.hiddenSpeakers = allSpeakersForSession.length - 3;
                _speakers.speakers = [];
                for (ii = 0; ii < 3; ii++) {
                    _speakers.speakers.push(allSpeakersForSession[ii]);
                }
            }

            detailedSession.id = session.id;
            detailedSession.startTime = session.startTime;
            detailedSession.endTime = session.endTime;
            detailedSession.title = session.title;
            detailedSession.location = session.roomId.title;
            detailedSession.isAttending = session.isAttend;
            detailedSession.speakers = _speakers //ObjectService.getSimpleObjectArray(e.apiContentTypes.Speaker, datacontext.getCachedSpeakers(session.speakerIds));
            detailedSession.tracks = session.trackIds;
            //detailedSession.tracks = ObjectService.getSimpleObjectArray(e.apiContentTypes.Track, datacontext.getCachedTracks(session.trackIds));

            _allSessions.push(detailedSession);
        }
        
        // Get array of sessions per day
        var sessionsPerDay = _.groupBy(_allSessions, function(item) {      
            // Tue Sep 20 2016 12:00:00 GMT+0200 - Wrong
            // 2019-01-17T13:45:00.000Z - Correct

            //var dateMoment = moment(moment.utc(item.startTime), "ddd MMM DD YYYY hh:mm:ss GMTZZ", "en");
            var dateMoment = moment(moment.utc(item.startTime)); // 11.01.18 Removed date formatting to solve issue?

            return dateMoment.format("YYYY-MM-DD");
        });

        // 07.03.2018 - FH: Removed comment for .sortBy('date) which had been commented earlier. Unsure of why it was commented, so 
        // should check this more deeply to make sure uncommenting it does not introduce any new issues
        try {
            var _allDays = _.chain(sessionsPerDay)
            .map((items, date) => {
                return {date: moment(items[0].startTime).toDate(), items} // 11.01.18 Removed date formatting to solve issue
            })
            .sortBy('date')
            .values();
        } catch (err) {
            var _allDays = _.chain(sessionsPerDay)
            .map((items, date) => {
                return {date: moment(items[0].startTime).toDate(), items} // 11.01.18 Removed date formatting to solve issue
            })
            //.sortBy('date')
            .values();
        }
        

        allDays = _allDays._wrapped;
        
        //datePickerIndex = allDays[0];

        //$scope.tracks = ObjectService.getSimpleObjectArray(e.apiContentTypes.Track, datacontext.getCachedTrack());
        $scope.tracks = datacontext.getCachedTrack();


        // Set selected value if it doesn't already exist
        angular.forEach($scope.tracks, function(item) {
            item.selected = (item.selected != undefined) ? item.selected : true;
        });
        
        if (allDays.length == 0) {
            $scope.emptyAgenda = true;
        } else {
            $scope.emptyAgenda = false;
        }
        setDatePicker(datePickerIndex);

    }

    function gotoToday() {

        var today = moment();
        
        for (var i = 0; i < allDays.length; ++i) {
            if (moment(allDays[i].date).isSame(today, 'day')) {
                setDatePicker(i);
            }
        }
    }


    function updateSelectedTracks() {

        selectedTracks = [];

        angular.forEach($scope.tracks, function (item) {
            if (item.selected) {
                selectedTracks.push(item.id);
            }
        });

        $scope.selectedTracks = {
            "trackIds": selectedTracks
        };

        
        
    }

    $scope.popoverFilterSelectAll = function() {
        angular.forEach($scope.tracks, function(item) {
            item.selected = true;
        });        
    };

    $scope.popoverFilterUnselectAll = function() {
        angular.forEach($scope.tracks, function(item) {
            item.selected = false;
        });
    };


    $scope.nextDateClicked = function() {
        setDatePicker(datePickerIndex + 1);
        $ionicScrollDelegate.scrollTop();
    }

    $scope.prevDateClicked = function() {
        setDatePicker(datePickerIndex - 1);
        $ionicScrollDelegate.scrollTop();
    }

    function setDatePicker(newIndex) {
        
        // Check if new index exists
        var newIndexValid = allDays.length > newIndex ? true : false;

        if (!newIndexValid) {
            return;
        }

        // Check if previous and/or next date is available

        var hasNext = allDays.length > (newIndex + 1) ? true : false;
        var hasPrev = newIndex == 0 ? false : true;

        datePickerIndex = newIndex;


        if (hasPrev) {
            $scope.prevDate = moment(allDays[datePickerIndex-1].date).locale(currentEvent.language.substring(0,2)).format("DD");
        } else {
            $scope.prevDate = "";
        }
        
        $scope.currentDate = { 
            day: moment(allDays[datePickerIndex].date).locale(currentEvent.language.substring(0,2)).format("dddd"), // 11.01.18 Removed date formatting to solve issue
            date: moment(allDays[datePickerIndex].date).locale(currentEvent.language.substring(0,2)).format("DD"), // 11.01.18 Removed date formatting to solve issue
            month: moment(allDays[datePickerIndex].date).locale(currentEvent.language.substring(0,2)).format("MMMM") // 11.01.18 Removed date formatting to solve issue
        }

        if (hasNext) {
            $scope.nextDate = moment(allDays[datePickerIndex+1].date).locale(currentEvent.language.substring(0,2)).format("DD");
        } else {
            $scope.nextDate = "";
        }

        updateSelectedTracks();

        loadAgendaItems();
        

    }

    function loadAgendaItems() {

        var result = [];
        
        if ($scope.agendaMode == e.agendaModes.Personalized) {
            result = _.filter(allDays[datePickerIndex].items, function(items){ return items.isAttending == 1; })
                                    ;
        } else {
            if (allDays[datePickerIndex] != undefined) {
                result = allDays[datePickerIndex].items;
            }
            
        }
        
        var filteredResult = filterForTracks(result, $scope.selectedTracks);

        $scope.agendaItems = _.sortBy(filteredResult, function(num) {
            return moment(num.startTime).toDate() 
        });
  
    }






    function filterForTracks(_agendaItems,_tracks) {
                
        var filteredSessions = [];

        for (var i = 0; i < _agendaItems.length; ++i) {

            if (_agendaItems[i].tracks === null || _agendaItems[i].tracks.length === 0) {
                // If trackIds length is 0, there has not been specified any particular trackIds.
                // In this case, item should be added independently of filter

                filteredSessions.push(_agendaItems[i]);
            }

            for (var j = 0; j < _tracks.trackIds.length; ++j) {

                if ('tracks' in _agendaItems[i]) {
                    if (_agendaItems[i].tracks instanceof Array) {

                        if (_agendaItems[i].tracks.indexOf(_tracks.trackIds[j]) !== -1) {  
                            filteredSessions.push(_agendaItems[i]);      
                            break;
                        }

                    }

                    if (typeof _agendaItems[i].tracks === 'number') {
                        if (_agendaItems[i].tracks == _tracks.trackIds[j]) { 
                            filteredSessions.push(_agendaItems[i]);
                            break;
                        }
                    }


                }

            }

        }

        return filteredSessions; 

    }

    $scope.activeFilter = function() {
        try {
            if ($scope.selectedTracks.trackIds.length == $scope.tracks.length) {
                return false;
            } else {
                return true;
            }
        } catch(e) {
            return false;
        }
        
    }

    $scope.filterMessageClicked = function() {
        $scope.popoverFilterSelectAll();
        updateSelectedTracks();
        loadAgendaItems();
    }

    $scope.changeAgendaMode = function(newMode) {
        $scope.agendaMode = newMode;
        loadAgendaItems();
        $ionicScrollDelegate.scrollTop();
    }

    $scope.toggleIsAttending = function(agendaItem) {

        scheduleItem = datacontext.getCachedScheduleItem(agendaItem.id);
        agendaItem.isAttending = !agendaItem.isAttending;
        scheduleItem.isAttend = agendaItem.isAttending;

        $ionicListDelegate.closeOptionButtons();

        datacontext.saveNewAttendingStatus(scheduleItem);

        loadAgenda();
        
    }

    $scope.showEndTime = function(startTime, endTime) {
        if (moment(endTime).isAfter(startTime)) {
            return false;
        } else {
            return true;
        }
    }

    $scope.refreshContent = function(forced) {
        datacontext.sync(forced).then(function() {
            $log.debug("Sync Completed (Agenda)");

            loadAgenda();

            $scope.$broadcast('scroll.refreshComplete');
        }).catch(function(err) {
            $log.debug("Fetch data failed. (agendacontroller.js): " + err);
            
        });
    }

    $scope.showAgendaDetails = function(agenda) {
        $log.debug("Opening AgendaID:" + agenda.title);
        $ionicHistory.nextViewOptions({
            animation: 'enter'
        });
        //    $ionicViewSwitcher.nextDirection('enter');
        $state.go("tabs.agendaDetails", {
            "agendaItemId": agenda.id
        });
    }

    // TRACKS MODAL // 

    $ionicModal.fromTemplateUrl('tracks_modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.modal = modal;
        //modal.show();
    });

    $scope.openModal = function () {
        $scope.modal.show();
    };

    $scope.closeModal = function () {
        updateSelectedTracks();
        loadAgendaItems();
        $scope.modal.hide();
    };

    // Cleanup the modal when we're done with it!
    $scope.$on('$destroy', function () {
        $scope.modal.remove();
    });

    // Execute action on hide modal
    $scope.$on('modal.hidden', function () {
        // Execute action
    });

    // Execute action on remove modal
    $scope.$on('modal.removed', function () {
        // Execute action
    });


}]);