controllers.controller('CreateProfileCtrl', ['$scope', '$rootScope', '$http', '$state', 'datacontext', 'session', 'appConstants', 'appConfiguration', '$ionicActionSheet', '$cordovaCamera', '$cordovaFile', '$ionicLoading', '$cordovaFileTransfer', '$ionicPlatform', '$log', 'PlatformCheck', 'ObjectService', '$cordovaDialogs', '$translate', 'AppService', 'AnalyticsService', '$ionicPopup', '$ionicHistory', '$stateParams', 'NotifyService', 'eventService', function ($scope, $rootScope, $http, $state, datacontext, session, appConstants, appConfiguration, $ionicActionSheet, $cordovaCamera, $cordovaFile, $ionicLoading, $cordovaFileTransfer, $ionicPlatform, $log, PlatformCheck, ObjectService, $cordovaDialogs, $translate, AppService, AnalyticsService, $ionicPopup, $ionicHistory, $stateParams, NotifyService, eventService) {



    //by default make it true..so that it wont show the red bar onload....
    $scope.data = {
        connection: true
    };

    $scope.$on('$ionicView.beforeEnter', function () {

        $scope.acceptedTerms = false;

        var currentEvent = $stateParams.currentEvent;
        console.log(currentEvent);
        console.log($stateParams.eventCode);

        $scope.logoImageUrl = currentEvent.imageUrl;

        NotifyService.subscribe($scope, 'notify-eventExited', function eventExited() {

            $scope.logoImageUrl = null;

        });

    });

    $scope.$on('$ionicView.enter', function () {

        //CHECKING FOR INTERNET CONNECTION...
        AppService.hasConnection().success(function () {
            //console.log("has connection");
            $scope.data = {
                connection: true
            };
        }).error(function (err) {
            //console.log("no connection");
            $scope.data = {
                connection: false
            };
        });



    });

    $scope.toggleCheck = function () {
        $scope.acceptedTerms = !$scope.acceptedTerms;
    };



    $scope.submitForm = function (firstName, lastName, company, position) {
        
        var profileData = {
            eventCode: $stateParams.eventCode, // required
            firstName: firstName, // required
            lastName: lastName, // required
            company: company, // optional
            position: position, // optional
        };


        var formvalid = validateForm(profileData);

        if (formvalid) {
            createProfile(profileData);
        }

    }

    function createProfile(profileData) {
        // Prepare payload
        // Show spinner
        $ionicLoading.show({
            template: '<ion-spinner></ion-spinner>'
        });
        $scope.profileData = profileData;
        // HTTP Request
        var payload = {
            eventCode: profileData.eventCode,
            firstName: profileData.firstName,
            lastName: profileData.lastName,
            company: profileData.company,
            position: profileData.position
        }
        var createProfile = session.createProfile(payload);
        createProfile.success(function (data, status) {
            $log.debug("PROFILE CREATED :-)");

            // Success
            // Set event token
            datacontext.clearData();
            var token = session.getToken();
            var userParticipantId = undefined;
            var eventToken = data.authToken;
            var currentEventId = $stateParams.currentEvent.id;

            session.create('', token, true, userParticipantId, eventToken);

            eventService.create(currentEventId);

            $ionicLoading.hide();

            $state.go("auth.sync", {forceProfileUpdate: true});
            
        }).error(function (response) {
            // Error handler
            //$scope.errorMessage = response.message;
            $translate.onReady().then(function () {
                $ionicPopup.alert({
                    title: $translate.instant('AUTH.CREATE_PROFILE.DIALOGS.REGISTRATION_ERROR.TITLE'),
                    template: $translate.instant('AUTH.CREATE_PROFILE.DIALOGS.REGISTRATION_ERROR.BODY')
                });
            }); 

            // Hide spinner
            $ionicLoading.hide();
        });
    }

    function validateForm(profileData) {
        var formIsValid = true;
        var validationError = "";

        console.log(profileData.firstName);

        if (profileData.firstName == "" || profileData.firstName == undefined) {
            formIsValid = false;
            validationError += $translate.instant('AUTH.CREATE_PROFILE.DIALOGS.VALIDATION_ERROR.FIRST_NAME');
        }
        if (profileData.lastName == "" || profileData.lastName == undefined) {
            formIsValid = false;
            validationError += $translate.instant('AUTH.CREATE_PROFILE.DIALOGS.VALIDATION_ERROR.LAST_NAME');
        }

        if (!$scope.acceptedTerms) {
            formIsValid = false;
            validationError += $translate.instant('AUTH.CREATE_PROFILE.DIALOGS.VALIDATION_ERROR.TERMS');
        }

        if (!formIsValid) {
            $translate.onReady().then(function () {
                $ionicPopup.alert({
                    title: $translate.instant('AUTH.CREATE_PROFILE.DIALOGS.VALIDATION_ERROR.TITLE'),
                    template: validationError
                });
            });
        }

        return formIsValid;

    }


}]);