controllers.controller('EditProfileCtrl', ['$scope', '$rootScope', '$http', '$state', 'datacontext', 'session', 'appConstants', 'appConfiguration', '$ionicActionSheet', '$cordovaCamera', '$cordovaFile', '$ionicLoading', '$cordovaFileTransfer', '$ionicPlatform', '$log', 'PlatformCheck', 'ObjectService', '$cordovaDialogs', '$translate', 'AppService', 'AnalyticsService', '$ionicHistory', function($scope, $rootScope, $http, $state, datacontext, session, appConstants, appConfiguration, $ionicActionSheet, $cordovaCamera, $cordovaFile, $ionicLoading, $cordovaFileTransfer, $ionicPlatform, $log, PlatformCheck, ObjectService, $cordovaDialogs, $translate, AppService, AnalyticsService, $ionicHistory) {


    var participantEntity = null;
    $scope.participant = null;

    //by default make it true..so that it wont show the red bar onload....
    $scope.data = {
        connection: true
    };

    $scope.isDevice = PlatformCheck.isDevice();

    //AppConstants values coming to show or hide the whole fields...
    $scope.showTwitter = appConstants.app.participantConfig.editProfile.twitter;
    $scope.showEmail = appConstants.app.participantConfig.editProfile.email;
    $scope.showLinkedIn = appConstants.app.participantConfig.editProfile.linkedIn;
    $scope.showMobile = appConstants.app.participantConfig.editProfile.mobile;
    $scope.showDescription = appConstants.app.participantConfig.editProfile.description;

    $scope.$on("$ionicView.beforeEnter", function() {
        // If navigation history is empty (ie. browser refresh) --> reset state to parent tab
        if ($ionicHistory.viewHistory().currentView.backViewId == null) {
            $ionicHistory.nextViewOptions({
                disableAnimate: true,
                disableBack: true
            });
            $state.go("tabs.menu");
        }       
    });

    $scope.$on('$ionicView.enter', function() {

        // Analytics
        AnalyticsService.startTimer("State Open");

        //CHECKING FOR INTERNET CONNECTION...
        AppService.hasConnection().success(function() {
            //console.log("has connection");
            $scope.data = {
                connection: true
            };
        }).error(function(err) {
            //console.log("no connection");
            $scope.data = {
                connection: false
            };
        });


        $translate.onReady().then(function() {
            $ionicLoading.show({
                template: $translate.instant('NAVIGATION.EDIT_PROFILE.MESSAGES.LOADING_PROFILE.BODY')
            });
        });

        datacontext.getProfile().then(function() {

            //TODO ADD LOADING

            participantEntity = datacontext.getCachedProfile(session.getLoggedInParticipantId());

            $scope.participant = ObjectService.getSimpleObject(e.apiContentTypes.Profile, participantEntity);


            var seen = []
            var json = JSON.stringify($scope.participant, function(key, val) {
                if (typeof val == "object") {
                    if (seen.indexOf(val) >= 0)
                        return
                    seen.push(val)
                }
                return val
            }, 0)

            $log.debug("PARTICIPANT OBJECT IN SCOPE " + json);

        }).catch(function(err) {

            $log.debug("Fetch participant failed: " + err);
        }).finally(function() {
            $ionicLoading.hide();
        });

    });

    $scope.$on('$ionicView.leave', function(e) {

        //console.log("saving...");
        $scope.saveProfile();

        var eventProperties = {
            "State Name": "Edit Profile"
        };
        AnalyticsService.trackEvent("State Open", eventProperties);
    });


    $scope.logout = function() {

        session.logout();

    }

    $scope.saveProfile = function() {
        // Check for connection
        AppService.hasConnection().success(function() {
            //console.log("has connection");
            $scope.data = {
                connection: true
            };
        }).error(function(err) {
            //console.log("no connection");
            $scope.data = {
                connection: false
            };
        });

        // If no connection, let user know that the profile will be update next time he connects
        if (!$scope.data.connection) {
            $translate.onReady().then(function() {
                $cordovaDialogs.alert($translate.instant('NAVIGATION.EDIT_PROFILE.MESSAGES.NO_CONNECTION.BODY'), $translate.instant('NAVIGATION.EDIT_PROFILE.MESSAGES.NO_CONNECTION.TITLE'));
            });
        } 

            // Get new values from form
            participantEntity.isPublicEmail = $scope.participant.isPublicEmail;
            participantEntity.isPublic = $scope.participant.isPublic;
            participantEntity.twitter = $scope.participant.twitter;
            participantEntity.description = $scope.participant.description;
            participantEntity.mobile = $scope.participant.mobile;
            participantEntity.linkedIn = $scope.participant.linkedIn;

            /*
            $translate.onReady().then(function() {
                $ionicLoading.show({
                    template: $translate.instant('NAVIGATION.EDIT_PROFILE.MESSAGES.SAVING.BODY')
                });
            });*/
            datacontext.saveProfile(participantEntity).then(function() {
                //$ionicLoading.hide();
            });

            /*
            seen = []
            json = JSON.stringify($scope.participant, function (key, val) {
                if (typeof val == "object") {
                    if (seen.indexOf(val) >= 0)
                        return
                    seen.push(val)
                }
                return val
            }, 4)
        
            $log.debug(json);*/

        

    }

    function uploadImage(imageUrl) {

        $translate.onReady().then(function() {
            $ionicLoading.show({
                template: $translate.instant('NAVIGATION.EDIT_PROFILE.MESSAGES.UPLOADING_IMAGE.BODY')
            });
        });

        var win = function(r) {
            $log.debug("Code = " + r.responseCode);
            $log.debug("Response = " + r.response.imageUrl);
            $log.debug("Sent = " + r.bytesSent);

            // Set temporary imageurl locally and save object
            var jsonResponse = JSON.parse(r.response);
            participantEntity.imageUrl = jsonResponse.imageUrl;

            datacontext.saveProfile(participantEntity).then(function() {
                $scope.participant.imageUrl = participantEntity.imageUrl;
                $ionicLoading.hide();
            });

        }

        var fail = function(error) {
            //TODO: Show alert
            $log.debug("An error has occurred: Code = " + error.code);
            //            $log.debug("upload error source " + error.source);
            //            $log.debug("upload error target " + error.target);
            $ionicLoading.hide();
        }

        var fileTransferOptions = new FileUploadOptions();
        $log.debug("FileTransferOptions:" + fileTransferOptions);
        fileTransferOptions.httpMethod = "PUT";
        fileTransferOptions.mimeType = "image/jpg";
        fileTransferOptions.headers = {
            Connection: "close",
            'X-ZUMO-AUTH': session.getEventToken()
        }
        fileTransferOptions.chunkedMode = false;

        var url = appConfiguration.apiUrl + "participant/image";

        var trimmedImageUrl = imageUrl; //for android...
        if (ionic.Platform.isIOS()) {
            var trimmedImageUrl = imageUrl.substr(7);
        }

        var ft = new FileTransfer();
        ft.upload(trimmedImageUrl, encodeURI(url), win, fail, fileTransferOptions);
    }

    $scope.showActionSheet = function() {

        var destinationType = null;
        if (ionic.Platform.isIOS()) {
            destinationType = Camera.DestinationType.FILE_URI;
        } else if (ionic.Platform.isAndroid()) {
            destinationType = Camera.DestinationType.FILE_URL;
        }

        var hideSheet = $ionicActionSheet.show({
            buttons: [{
                text: 'Take Photo'
            }, {
                text: 'Choose Existing Photo'
            }, {
                text: 'Remove Photo'
            }],
            titleText: 'Change Profile Picture',
            cancelText: 'Cancel',
            cancel: function() {

            },
            buttonClicked: function(index) {
                switch (index) {
                    case 0:
                        {
                            // Take Photo
                            var options = {
                                quality: 75,
                                destinationType: destinationType,
                                sourceType: Camera.PictureSourceType.CAMERA,
                                allowEdit: true,
                                correctOrientation: true,

                                encodingType: Camera.EncodingType.JPEG,
                                popoverOptions: CameraPopoverOptions,
                                targetWidth: 500,
                                targetHeight: 500,
                                saveToPhotoAlbum: false
                            };
                            $cordovaCamera.getPicture(options).then(function(imageUrl) {
                                $log.debug("Image taken successfully");
                                $scope.lastPhoto = imageUrl;
                                uploadImage(imageUrl);
                            }, function(error) {
                                $log.debug(error);
                            });
                            break;
                        }
                    case 1:
                        {
                            // upload from file system / gallery...
                            var options = {
                                quality: 75,
                                destinationType: destinationType,
                                sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                                allowEdit: true,
                                encodingType: Camera.EncodingType.JPEG,
                                popoverOptions: CameraPopoverOptions,
                                targetWidth: 500,
                                targetHeight: 500,
                                saveToPhotoAlbum: false
                            };

                            $cordovaCamera.getPicture(options).then(function(imageUrl) {

                                $log.debug("Image fetched successfully:" + imageUrl);

                                uploadImage(imageUrl);

                            }, function(error) {
                                $log.debug(error);
                            });

                            break;
                        }
                    case 2:
                        {

                            $translate.onReady().then(function() {
                                $ionicLoading.show({
                                    template: $translate.instant('NAVIGATION.EDIT_PROFILE.MESSAGES.UPLOADING_IMAGE.BODY')
                                });
                            });

                            $http.delete(appConfiguration.apiUrl + "participant/image").success(function(r) {
                                // Delete profile image success, update local cache and save to make sure backend and app is in sync

                                // Set temporary imageurl locally and save object
                                participantEntity.imageUrl = "";

                                datacontext.saveProfile(participantEntity).then(function() {
                                    $log.debug("New imageUrl after sync: " + participantEntity.imageUrl);
                                    $scope.participant.imageUrl = participantEntity.imageUrl;
                                    $ionicLoading.hide();
                                });

                            }).error(function(error) {

                                //TODO: Show error message to user

                                $log.debug("There was an error deleting the profile image");
                                $log.debug("An error has occurred: Code = " + error.code);
                                $log.debug("upload error source " + error.source);
                                $log.debug("upload error target " + error.target);
                                $ionicLoading.hide();

                            });

                            break;
                        }

                }

                return true;
            }

        });
    }

}]);