controllers.controller('EnablePushNotificationsController', ['$scope', 'PushService', 'datacontext', 'session', 'eventService', '$state', 'ObjectService','$log','AnalyticsService', function ($scope, PushService, datacontext, session, eventService, $state, ObjectService,$log,AnalyticsService) {

    $scope.$on('$ionicView.enter', function () {
       
        // Analytics
        if (!ionic.Platform.isWebView()) {
            trackProfileView();
        } else {
            AnalyticsService.startTimer("Login State Open");
        }
    });

    function trackProfileView() {
        var eventProperties = {
            "Login State Open": "Enable Push Notifications State"
        };
        AnalyticsService.trackEvent("Login State Open", eventProperties);
    }

    $scope.$on('$ionicView.leave', function (e) {
        if (ionic.Platform.isWebView()) {
            trackProfileView();
        }
    });

    $scope.enablePushNotifications = function () {
        $log.debug("Calling registerdevice");
        PushService.registerDevice();
        var eventProperties = {
            "Response": "Enable"
        };
        AnalyticsService.trackEvent("Enable Push Notification Pre Question Response", eventProperties);
        enterApp();
        //$state.go("multi.eventList");
    }

    $scope.noAction = function () {
        var eventProperties = {
            "Response": "Skip"
        };
        AnalyticsService.trackEvent("Enable Push Notification Pre Question Response", eventProperties);

        enterApp();
        //$state.go("multi.eventList");
    }

    function enterApp() {
        // If one event available AND this event should be autoloading --> Open Event. Else --> go to multi-list

        datacontext.getEvents().then(function () {
            var currentEvents = ObjectService.getSimpleObjectArray(e.apiContentTypes.Event, datacontext.getCachedEvents());
            //$log.debug("Current Events: " + JSON.stringify(currentEvents));
            //$log.debug("New Count: " + currentEvents.length + ". Object: " + JSON.stringify(currentEvents) + ". Autoload: " + currentEvents[0].autoloadEvent);
            if (currentEvents) {
                if (currentEvents.length == 1 && currentEvents[0] && currentEvents[0].autoloadEvent) {
                   // $log.debug("app.js: 1 event, data available, autoload true");
                    datacontext.clearData();

                    var token = session.getToken();
                    var userParticipantId = session.getLoggedInParticipantId();
                    var eventToken = currentEvents[0].authToken;
                    var currentEventId = currentEvents[0].id;

                    session.create('', token, true, userParticipantId, eventToken);

                    eventService.create(currentEventId);

                    $state.go("auth.sync");
                } else {
                   // $log.debug("app.js: conditions false, loading multi list");
                    $state.go("multi.eventList");
                }
            } // end of big if...
        });
    }


}]);