controllers.controller('ExhibitorCtrl', ['$scope', '$state', 'datacontext', '$ionicScrollDelegate', '$stateParams', '$log', 'AnalyticsService', '$ionicHistory', function($scope, $state, datacontext, $ionicScrollDelegate, $stateParams, $log, AnalyticsService, $ionicHistory) {

    $scope.exhibitors = null;

    $scope.$on("$ionicView.beforeEnter", function() {
        // If navigation history is empty (ie. browser refresh) --> reset state to parent tab
        if ($ionicHistory.viewHistory().currentView.backViewId == null) {
            $ionicHistory.nextViewOptions({
                disableAnimate: true,
                disableBack: true
            });
            $state.go("tabs.menu");
        }       
    });

    $scope.$on('$ionicView.enter', function(e) {
        
        // Analytics
        AnalyticsService.startTimer("State Open");

        $scope.exhibitors = datacontext.getCachedExhibitors();
        $ionicScrollDelegate.resize()
        $scope.refreshContent();


    });

    $scope.$on('$ionicView.leave', function(e) {
        var eventProperties = {
            "State Name": "Exhibitor List"
        };
        AnalyticsService.trackEvent("State Open", eventProperties);
    });

    /* THIS WILL SET THE HEIGHT OF EACH ITEM...*/
    $scope.setItemHeight = function(companyName) {
        //if the sub-heading is too long...set size big...
        var totalChars = 0;
        if (companyName != null) {
            totalChars = companyName.length;
        }
        if (totalChars < 28 && totalChars >= 1) //if subheader is more than 50 chars....then bigItem height....
            return '80px';
        else if (totalChars < 61 && totalChars >= 28)
            return '100px';
        else
            return '122px';

        return '20px'; //This will be used for sectionHeader.....
    }

    $scope.refreshContent = function(forced) {

        // Call sync to get updated content
        datacontext.sync(forced).then(function() {

            $log.debug("Sync Completed (exhibitorController.js)");

            // Update list from cache
            $scope.exhibitors = datacontext.getCachedExhibitors();

            // Tell the refresher the refresh is complete
            $scope.$broadcast('scroll.refreshComplete');



        }).catch(function(err) {
            $log.debug("Fetch data failed. (exhibitorController.js): " + err);

        });
    }

}]);