controllers.controller('ExhibitorDetailCtrl', ['$scope', '$state', 'datacontext', 'exhibitor', '$ionicScrollDelegate', 'PushService', '$stateParams', '$log','$cordovaInAppBrowser', 'AnalyticsService', '$cordovaEmailComposer', '$ionicHistory', 'PlatformCheck', function ($scope, $state, datacontext, exhibitor, $ionicScrollDelegate, PushService, $stateParams, $log,$cordovaInAppBrowser, AnalyticsService, $cordovaEmailComposer, $ionicHistory, PlatformCheck) {
    
    
    $scope.exhibitor = null;
    
    $scope.$on("$ionicView.beforeEnter", function() {
        // If navigation history is empty (ie. browser refresh) --> reset state to parent tab
        if ($ionicHistory.viewHistory().currentView.backViewId == null) {
            $ionicHistory.nextViewOptions({
                disableAnimate: true,
                disableBack: true
            });
            $state.go("tabs.menu");
        }       
    });

    $scope.$on('$ionicView.enter', function (e) {
        
        $scope.exhibitor = exhibitor;

        // Analytics
        if (!ionic.Platform.isWebView()) {
            trackProfileView();
        } else {
            AnalyticsService.startTimer("Exhibitor Profile State Open");
        }

        
        $ionicScrollDelegate.resize()
        $scope.refreshContent();
        
       
    });
    
    $scope.$on('$ionicView.leave', function (e) {
        if (ionic.Platform.isWebView()) {
            trackProfileView();
        }
    });
    
    function trackProfileView() {
        var eventProperties = {
            "State Name": "Exhibitor Profile",
            "Exhibitor Id": $scope.exhibitor.id,
            "Exhibitor Company Name": $scope.exhibitor.companyName
        };
        AnalyticsService.trackEvent("Exhibitor Profile State Open", eventProperties);
    }
    
    $scope.openURL = function (url) {
        if (PlatformCheck.isDevice()) {
            window.open(url, '_blank', 'location=yes');
        } else {
            window.open(url, '_self', 'location=yes');
        }
    };
	
	$scope.openMail = function(email) {
        $log.debug("openMail Clicked");
        
        $log.debug("email available");
        var newMail = {
            to: email
        };

        $cordovaEmailComposer.open(newMail).then(null, function() {
            // User cancelled email
        });
        
    };
    
    $scope.refreshContent = function (forced) {

        // Call sync to get updated content
        datacontext.sync(forced).then(function () {

            $log.debug("Sync Completed (exhibitorDetails.js)");

            // Update list from cache
            $scope.exhibitor = datacontext.getCachedExhibitorProfile($stateParams.exhibitorId);
            
            // Tell the refresher the refresh is complete
            $scope.$broadcast('scroll.refreshComplete');



        }).catch(function (err) {
            $log.debug("Fetch data failed. (app.js): " + err);

        });
    }
	
	
}]);