controllers.controller('FeedCtrl', ['$scope', '$state', 'datacontext', 'appConstants', '$timeout', '$ionicActionSheet', '$log', 'PlatformCheck', '$translate', 'FlagContentService', 'eventService', 'toaster', 'AnalyticsService', 'ObjectService', '$ionicScrollDelegate', '$filter', function ($scope, $state, datacontext, appConstants, $timeout, $ionicActionSheet, $log, PlatformCheck, $translate, FlagContentService, eventService, toaster, AnalyticsService, ObjectService, $ionicScrollDelegate, $filter) {


    $scope.externalFeedPosts = [];
    $scope.hasMoreData = false;
    
    var allExternalPosts = [];
    var showUntil = 0;    
    var loadInterval = 10;
    var isLoading = false;

    $scope.loadMore = function() {
        if (!isLoading && showUntil >= 10) {

            isLoading = true;
            var currentLength = showUntil;

            if ((showUntil + loadInterval) <= allExternalPosts.length) {
                showUntil = showUntil + loadInterval;
                $scope.hasMoreData = true;
            } else {
                showUntil = allExternalPosts.length;
                $scope.hasMoreData = false;
            }
            
            for (var i = currentLength; i <= showUntil; i++) {
                $scope.externalFeedPosts.push(allExternalPosts[i]);
            }  
            
            $scope.$broadcast('scroll.infiniteScrollComplete'); 
            isLoading = false;
        }
        
    }



    $scope.$on('$ionicView.enter', function () {
        $ionicScrollDelegate.scrollTop();
        AnalyticsService.startTimer("State Open");
        
        
        if ($scope.logoImageUrl == null || $scope.logoImageUrl == undefined){
            var currentEvent = ObjectService.getSimpleObject(e.apiContentTypes.Event, datacontext.getCachedEventInformation(eventService.getId()));
            $scope.logoImageUrl = currentEvent.imageUrl;
        }
        
        $scope.isDevice = PlatformCheck.isDevice();
        
        allExternalPosts = ObjectService.getSimpleObjectArray(e.apiContentTypes.ExternalPost, datacontext.getCachedFeedExternalContent())
        allExternalPosts = $filter('filter')(allExternalPosts, {isDeleted: '!true'});
        allExternalPosts = $filter('orderBy')(allExternalPosts, '-createdAt');
        
        showUntil = (allExternalPosts.length > loadInterval) ? loadInterval : allExternalPosts.length;
        $scope.externalFeedPosts = allExternalPosts.slice(0,showUntil);
        $scope.hasMoreData = (allExternalPosts.length > loadInterval) ? true : false;
        $scope.refreshContent();

        
        //$log.debug("Number of speakers: " + $scope.scheduleItems[0].speakers.length);
    });
    
    $scope.$on('$ionicView.leave', function (e) {
        var eventProperties = {"State Name": "Feed"};
        AnalyticsService.trackEvent("State Open", eventProperties);
    });

    /*

    $scope.$on('$ionicView.enter', function (e) {


        
        // JUST FOR TESTING
        
        $log.debug("Entering feed controller");
        
        var scheduleItems = datacontext.getCachedScheduleItems();
        
        $log.debug("Track: " + scheduleItems[0].trackId.title);
        
        /*
        
        $scope.scheduleItems = datacontext.getCachedScheduleItems();
        
        $scope.scheduleItems[0].isAttending = true;
        
        //datacontext.saveNewAttendingStatus($scope.scheduleItems[0]);
        
        $scope.speaker = datacontext.getCachedSpeaker(1057);
        
        $log.debug("Speaker fetch: " + $scope.speaker.firstName);
        
        
        seen = []
        json = JSON.stringify($scope.speaker, function (key, val) {
            if (typeof val == "object") {
                if (seen.indexOf(val) >= 0)
                    return
                seen.push(val)
            }
            return val
        }, 0)
        
        //$log.debug(json);
        
        $log.debug("ScheduleItems: " + $scope.scheduleItems[0].speakers[1].firstName);
        
        */
    /*

    });
*/

    $scope.showActionSheet = function () {
        
        $translate.onReady().then(function () {
            $scope.syncMessageTitle = $translate.instant('AUTH.SYNC.IN_PROGRESS.TITLE');
            $scope.syncMessage = $translate.instant('AUTH.SYNC.IN_PROGRESS.BODY');

            $log.debug("BUTTON CLICKED");
            var hideSheet = $ionicActionSheet.show({
                buttons: [
                    {
                        text: $translate.instant('NAVIGATION.FEED.ACTIONS.POST_TWITTER')
                }
                    /*,
                                    {
                                        text: $translate.instant('NAVIGATION.FEED.ACTIONS.POST_INSTAGRAM')
                                    }*/
            ],
                titleText: $translate.instant('NAVIGATION.FEED.ACTIONS.MENU_TITLE'),
                cancelText: $translate.instant('NAVIGATION.FEED.ACTIONS.CANCEL'),
                cancel: function () {

                },
                buttonClicked: function (index) {
                    switch (index) {
                    case 0:
                        {
                            $log.debug("POST TO TWITTER CLICKED");

                            AnalyticsService.trackEvent("Compose Tweet Button Clicked");

                            var eventInformation = datacontext.getCachedEventInformation(eventService.getId());

                            window.plugins.socialsharing.shareViaTwitter(eventInformation.hashtags);
                            // TODO: ADD HASHTAGS FROM EVENTINFO

                            break;
                        }
                    case 1:
                        {
                            $log.debug("POST TO INSTAGRAM CLICKED");

                            window.open("instagram://camera", '_system');

                            // TODO: Add hook for Android Intent
                            // TODO: Add default caption text if possible

                            break;
                        }

                    }

                    return true;
                }

            });


        });




    };

    $scope.refreshContent = function () {

        // Call sync to get updated content
        datacontext.sync().then(function () {

            $log.debug("Sync Completed (syncController.js)");

            // Update list from cache
            
            allExternalPosts = ObjectService.getSimpleObjectArray(e.apiContentTypes.ExternalPost, datacontext.getCachedFeedExternalContent())
            allExternalPosts = $filter('filter')(allExternalPosts, {isDeleted: '!true'});
            allExternalPosts = $filter('orderBy')(allExternalPosts, '-createdAt');

            if (loadInterval <= allExternalPosts.length) {
                showUntil = loadInterval;
                $scope.hasMoreData = true;
                
            } else {
                showUntil = allExternalPosts.length;
                $scope.hasMoreData = false;
            }
            $scope.externalFeedPosts = allExternalPosts.slice(0,showUntil);

            // Tell the refresher the refresh is complete
            $scope.$broadcast('scroll.refreshComplete');



        }).catch(function (err) {
            $log.debug("Fetch data failed. (app.js): " + err);

        });
    }

    $scope.flagContent = function (postId) {
        FlagContentService.flagContent(e.apiContentTypes.ExternalPost, postId);
    }
}]).filter('getTitle', function() {
  return function(input) {
      var text = JSON.parse(input);
    return text.title;
  };
}).filter('getMessage', function() {
  return function(input) {
      var text = JSON.parse(input);
    return text.message;
  };
});