controllers.controller('FeedDetailsLikesCtrl', ['$scope', '$state', 'datacontext', 'appConstants', 'post', 'FeedService', '$ionicHistory', function ($scope, $state, datacontext, appConstants, post, FeedService, $ionicHistory) {

    $scope.likes = [];
    $scope.isLoadingLikes = true;

    $scope.$on("$ionicView.beforeEnter", function() {
        // If navigation history is empty (ie. browser refresh) --> reset state to parent tab
        if ($ionicHistory.viewHistory().currentView.backViewId == null) {
            $ionicHistory.nextViewOptions({
                disableAnimate: true,
                disableBack: true
            });
            $state.go("tabs.feed");
        }       
    });

    $scope.$on('$ionicView.enter', function () {
        fetchLikes();
    });

    $scope.goToParticipant = function(participantId) {
        if ($state.current.name == "tabs.feedDetailsLikes") {
            $state.go("tabs.participantDetailsFromFeed", {"participantId": participantId});
        } else if ($state.current.name == "tabs.feedDetailsLikesFromMenu") {
            $state.go("tabs.participantDetails", {"participantId": participantId});
        }
        
    }

    function fetchLikes() {
        var likesRequest = FeedService.getLikes(post.id);
        likesRequest.then(function (results) {

            $scope.isLoadingLikes = false;
            $scope.likes = results.data;

        }, function () {
            $scope.isLoadingComments = false;
        });
    }


}]);