controllers.controller('ImageGalleryCtrl', ['$scope', 'datacontext', 'appConstants', '$ionicHistory', 'screenSize', 'ObjectService', '$filter', '$state', 'NotifyService', function ($scope, datacontext, appConstants, $ionicHistory, screenSize, ObjectService, $filter, $state, NotifyService) {

    $scope.desktop = screenSize.on('md, lg', function (match) {
        $scope.desktop = match;
    });
    $scope.pad = screenSize.on('sm', function (match) {
        $scope.pad = match;
    });
    $scope.mobile = screenSize.on('xs', function (match) {
        $scope.mobile = match;
    });

    $scope.$on("$ionicView.beforeEnter", function () {
        // If navigation history is empty (ie. browser refresh) --> reset state to parent tab
        if ($ionicHistory.viewHistory().currentView.backViewId == null) {
            $ionicHistory.nextViewOptions({
                disableAnimate: true,
                disableBack: true
            });
            $state.go("tabs.menu");
        } else {            
            NotifyService.subscribe($scope, 'notify-eventExited', function eventExited() {
                $scope.images = [];
            });
        }
    });

    $scope.$on("$ionicView.beforeEnter", function() {
        loadImages();              

    });

    function loadImages() {
        var images = ObjectService.getSimpleObjectArray(e.appContentTypes.Gallery, datacontext.getCachedFeedExternalContent())
        images = $filter('filter')(images, {
            isDeleted: '!true'
        });
        images = $filter('orderBy')(images, '-createdAt');
        
        $scope.images  = images;
    }

    $scope.gotoImage = function(image) {
        if (image.sourceType == e.feedSourceTypes.Participant || image.sourceType == e.feedSourceTypes.Organizer) {
            $state.go("tabs.feedDetailsFromMenu", {"postId": image.id});
        } else if (image.sourceType == e.feedSourceTypes.Exhibitor) {
            $state.go("tabs.exhibitorDetails", {"exhibitorId": image.exhibitorId.id});
        }
        
    }
}]);