controllers.controller('InfoPageCtrl', ['$scope', '$state', 'datacontext', 'infoPage', '$ionicScrollDelegate', 'PushService', '$stateParams', '$log', 'AnalyticsService', '$translate', 'session', 'ObjectService', '$ionicHistory', function ($scope, $state, datacontext, infoPage, $ionicScrollDelegate, PushService, $stateParams, $log, AnalyticsService, $translate, session, ObjectService, $ionicHistory) {



    $scope.infoPage = null;

    $scope.$on("$ionicView.beforeEnter", function () {
        // If navigation history is empty (ie. browser refresh) --> reset state to parent tab
        if ($ionicHistory.viewHistory().currentView.backViewId == null) {
            $ionicHistory.nextViewOptions({
                disableAnimate: true,
                disableBack: true
            });
            $state.go("tabs.menu");
        }
    });

    $scope.$on('$ionicView.enter', function () {


        if ($stateParams.infoPageId == "customField") {
            $scope.infoPage = [];
            $translate.onReady().then(function () {
                $scope.infoPage.title = $translate.instant('NAVIGATION.INFO_PAGE.CUSTOM_FIELD.VIEW_TITLE');
            });
            //$scope.infoPage.title = "TEST";

            participantEntity = datacontext.getCachedProfile(session.getLoggedInParticipantId());
            var currentUser = ObjectService.getSimpleObject(e.apiContentTypes.Participant, participantEntity);
            $scope.infoPage.content = currentUser.customField;
        } else {
            $scope.infoPage = infoPage;
            $scope.refreshContent();
        }


        // Analytics
        if (!ionic.Platform.isWebView()) {
            trackProfileView();
        } else {
            AnalyticsService.startTimer("Infopage State Open");
        }


        $ionicScrollDelegate.resize()
        


    });

    $scope.$on('$ionicView.leave', function (e) {
        if (ionic.Platform.isWebView()) {
            trackProfileView();
        }
    });

    function trackProfileView() {
        var eventProperties = {
            "State Name": "Infopage",
            "Infopage Id": $scope.infoPage.id,
            "Infopage Title": $scope.infoPage.title
        };
        AnalyticsService.trackEvent("Infopage State Open", eventProperties);
    }

    $scope.openURL = function (link) {
        $log.debug("Did you just call me !");
        window.open(link, '_blank');
    }

    $scope.refreshContent = function (forced) {

        // Call sync to get updated content
        datacontext.sync(forced).then(function () {

            $log.debug("Sync Completed (syncController.js)");

            // Update list from cache
            $scope.infoPage = datacontext.getCachedInfoPage($stateParams.infoPageId);

            // Tell the refresher the refresh is complete
            $scope.$broadcast('scroll.refreshComplete');



        }).catch(function (err) {
            $log.debug("Fetch data failed. (app.js): " + err);

        });
    }
}]);