controllers.controller('LoginCtrl', ['$scope', '$state', '$timeout', '$q', 'session', 'appConstants', 'appConfiguration', 'appValues', '$ionicHistory', '$ionicLoading', '$cordovaDialogs', '$window', '$log', 'PlatformCheck', '$translate', 'datacontext', 'eventService', 'ObjectService', function ($scope, $state, $timeout, $q, session, appConstants, appConfiguration, appValues, $ionicHistory, $ionicLoading, $cordovaDialogs, $window, $log, PlatformCheck, $translate, datacontext, eventService, ObjectService) {
    /*
    if (session.isAuthorized())
        $state.transitionTo("tab.feeds");
        
        */

    $scope.loginButtonsDisabled = false;

    $scope.isDevice = PlatformCheck.isDevice();

    $scope.$on('$ionicView.enter', function (e) {

        $log.debug("Test Log from $log");

        $log.debug("pinVerificationEmail: " + $scope.credentials.pinVerificationEmail);
        if ($scope.credentials.pinVerificationEmail == ''  || $scope.credentials.pinVerificationEmail == null || $scope.credentials.pinVerificationEmail == undefined) {
            $log.debug("pinVerificationEmail: " + $window.localStorage.getItem(appConfiguration.localStorageKeys.auth.lastUsedEmailKey));
            $scope.credentials.pinVerificationEmail = $window.localStorage.getItem(appConfiguration.localStorageKeys.auth.lastUsedEmailKey);
        }

    });




    $scope.hideActionButton = false;
    $scope.tagLine = appConstants.app.tagLine;

    $translate.onReady().then(function () {
        $scope.verificationErrorMessage = $translate.instant('AUTH.VERIFICATION_ERROR.FIRST_TIME.BODY'); // appConstants.app.messages.verificationErrorMessage;
        $scope.verificationErrorMessageTitle = $translate.instant('AUTH.VERIFICATION_ERROR.FIRST_TIME.TITLE'); // appConstants.app.messages.verificationErrorMessageTitle;
    });

    $scope.credentials = {
        email: "",
        appId: appConstants.app.appId
    };

    $scope.errorMessage = '';

    $scope.authorize = function () {
        $scope.loginButtonsDisabled = true;
        $translate.onReady().then(function () {
            $ionicLoading.show({
                template: $translate.instant('AUTH.VERIFYING_USER_MESSAGE')
            });
        });
        $log.debug("Button clicked");

        if (!$scope.credentials.email) {
            $translate.onReady().then(function () {
                $ionicLoading.hide();
                $cordovaDialogs.alert($translate.instant('AUTH.LOGIN_EMAIL.MESSAGES.VALIDATION_ERROR.BODY'), $translate.instant('AUTH.LOGIN_EMAIL.MESSAGES.VALIDATION_ERROR.TITLE'));
            });
            $scope.loginButtonsDisabled = false;
            return;
        }


        $scope.errorMessage = '';

        var verification = session.requestToken($scope.credentials);
        verification.success(function (data, status) {
            $log.debug("Verification (" + status + "): Email Sent: " + $scope.credentials.email);
            $window.localStorage.setItem(appConfiguration.localStorageKeys.auth.lastUsedEmailKey, $scope.credentials.email);
            $log.debug("email set: " + $window.localStorage.getItem(appConfiguration.localStorageKeys.auth.lastUsedEmailKey));
            $ionicLoading.hide();
            if ($scope.credentials.email == appConstants.auth.demoLoginEmail) {

                if (PlatformCheck.isDevice()) {
                    $scope.loginButtonsDisabled = false;
                    $state.go("auth.enablePushNotifications");
                } else {
                    $scope.loginButtonsDisabled = false;
                    $state.go("multi.eventList");
                }


            } else {
                $scope.loginButtonsDisabled = false;
                $state.go("auth.verificationSuccess");
            }

        }).error(function (response) {
            //$scope.errorMessage = response.message;

            $translate.onReady().then(function () {
                $scope.loginButtonsDisabled = false;
                $ionicLoading.hide();
                $cordovaDialogs.alert($translate.instant('AUTH.LOGIN_EMAIL.MESSAGES.GENERAL_ERROR.BODY'), $translate.instant('AUTH.LOGIN_EMAIL.MESSAGES.GENERAL_ERROR.TITLE'));
                $log.debug("Error: " + response);
            });
        });

        return false;
    };

    $scope.verifyToken = function () {

        $log.debug("verify token clicked");


        $translate.onReady().then(function () {
            $ionicLoading.show({
                template: $translate.instant('AUTH.VERIFYING_USER_MESSAGE')
            });
        });

        var token = appValues.verificationToken;

        $log.debug(token);

        if (!token || token === '') {
            $log.debug("Hiding $ionicLoading");
            $ionicLoading.hide();

            $translate.onReady().then(function () {
                $scope.verificationErrorMessage = $translate.instant('AUTH.VERIFICATION_ERROR.SECOND_TIME.BODY'); // appConstants.app.messages.verificationErrorMessage;
                $scope.verificationErrorMessageTitle = $translate.instant('AUTH.VERIFICATION_ERROR.SECOND_TIME.TITLE'); // appConstants.app.messages.verificationErrorMessageTitle;
            });

            $scope.hideActionButton = true;
            return;
        }

        var credentials = {
            token: token,
            appId: appConstants.app.appId
        }

        $log.debug(credentials);

        var errorMessage = '';


        var authentication = session.verifyLogin(credentials);
        authentication.success(function (data, status) {
            $timeout(function () {
                $log.debug("Verification (" + status + "): Verified!");
                $log.debug("Hiding $ionicLoading");
                $ionicLoading.hide();
                if (PlatformCheck.isDevice()) {
                    $state.go("auth.enablePushNotifications");
                } else {
                    enterApp();
                    //$state.go("multi.eventList");
                }
                //$state.go("multi.eventList");
            }, appConstants.app.debugging.standardTimeoutDelay);

        }).error(function (response) {
            // TODO: Add error handling
            $log.debug("Hiding $ionicLoading");
            $ionicLoading.hide();

            $translate.onReady().then(function () {
                $scope.verificationErrorMessage = $translate.instant('AUTH.VERIFICATION_ERROR.SECOND_TIME.BODY'); // appConstants.app.messages.verificationErrorMessage;
                $scope.verificationErrorMessageTitle = $translate.instant('AUTH.VERIFICATION_ERROR.SECOND_TIME.TITLE'); // appConstants.app.messages.verificationErrorMessageTitle;
            });

            $scope.hideActionButton = true;

            errorMessage = response.message;
            $log.debug("Error: " + response.message);
        });


    }

    $scope.verifyPIN = function () {
        $log.debug("verify PIN clicked");
        $scope.loginButtonsDisabled = true;




        var pin = $scope.credentials.pin;
        var email = $scope.credentials.pinVerificationEmail;

        $log.debug("pin:"+pin);


        if (!pin || pin == '' || !email || email == '') {



            //TODO ERROR MESSAGE

            /*
            $translate.onReady().then(function () {
                $scope.verificationErrorMessageTitle = $translate.instant('AUTH.VERIFICATION_ERROR.SECOND_TIME.TITLE'); // appConstants.app.messages.verificationErrorMessageTwoTitle;
                $scope.verificationErrorMessage = $translate.instant('AUTH.VERIFICATION_ERROR.SECOND_TIME.BODY'); // appConstants.app.messages.verificationErrorMessageTwo;
                $ionicLoading.hide();
            });
            $scope.hideActionButton = true;

            $ionicLoading.hide();
            $state.go("auth.verificationError");
            */
            //$log.debug("Hiding $ionicLoading");
            //$ionicLoading.hide();
            $cordovaDialogs.alert($translate.instant('AUTH.LOGIN_PIN.MESSAGES.VALIDATION_ERROR.BODY'), $translate.instant('AUTH.LOGIN_PIN.MESSAGES.VALIDATION_ERROR.TITLE'));
            $scope.loginButtonsDisabled = false;

            return;
        }

        $translate.onReady().then(function () {
            $ionicLoading.show({
                template: $translate.instant('AUTH.VERIFYING_USER_MESSAGE')
            });
        });

        var credentials = {
            pin: pin,
            email: $scope.credentials.pinVerificationEmail,
            appId: appConstants.app.appId
        }

        $log.debug(credentials);

        var errorMessage = '';


        var authentication = session.verifyPIN(credentials);
        authentication.success(function (data, status) {
            $timeout(function () {
                $log.debug("Verification (" + status + "): Verified!");
                $log.debug("Hiding $ionicLoading");
                $ionicLoading.hide();
                if (PlatformCheck.isDevice()) {
                    $scope.loginButtonsDisabled = false;
                    $state.go("auth.enablePushNotifications");
                } else {
                    $scope.loginButtonsDisabled = false;
                    enterApp();
                    //$state.go("multi.eventList");
                }
            }, appConstants.app.debugging.standardTimeoutDelay);
        }).error(function (response) {
            // TODO: Add error handling
            $log.debug("Hiding $ionicLoading");
            $ionicLoading.hide();
            $scope.loginButtonsDisabled = false;
            $cordovaDialogs.alert($translate.instant('AUTH.LOGIN_PIN.MESSAGES.VALIDATION_ERROR.BODY'), $translate.instant('AUTH.LOGIN_PIN.MESSAGES.VALIDATION_ERROR.TITLE'));
            /*
            //TODO ERROR MESSAGES
            $translate.onReady().then(function () {
                $scope.verificationErrorMessageTitle = $translate.instant('AUTH.VERIFICATION_ERROR.SECOND_TIME.TITLE'); // appConstants.app.messages.verificationErrorMessageTwoTitle;
                $scope.verificationErrorMessage = $translate.instant('AUTH.VERIFICATION_ERROR.SECOND_TIME.BODY'); // appConstants.app.messages.verificationErrorMessageTwo;
            });

            $scope.hideActionButton = true;

            errorMessage = response.message;
            $log.debug("Error: " + response.message);
            */
        });
    };

    function enterApp() {
        // If one event available AND this event should be autoloading --> Open Event. Else --> go to multi-list
        try {
            datacontext.getEvents().then(function () {
                var currentEvents = ObjectService.getSimpleObjectArray(e.apiContentTypes.Event, datacontext.getCachedEvents());
                $log.debug("Count: " + currentEvents.length + ". Object: " + JSON.stringify(currentEvents[0])); //+ ". Autoload: " + currentEvents[0].autoloadEvent);
                if (currentEvents.length == 1 && currentEvents[0] && currentEvents[0].autoloadEvent) {
                    $log.debug("app.js: 1 event, data available, autoload true");
                    datacontext.clearData();

                    var token = session.getToken();
                    var userParticipantId = session.getLoggedInParticipantId();
                    var eventToken = currentEvents[0].authToken;
                    var currentEventId = currentEvents[0].id;

                    session.create('', token, true, userParticipantId, eventToken);

                    eventService.create(currentEventId);

                    $state.go("auth.sync");
                } else {
                    $log.debug("app.js: conditions false, loading multi list");
                    $state.go("multi.eventList");
                }
            });
        } catch (e) {
            $state.go("multi.eventList");
        }


    }

    $scope.clearHistory = function () {
        $ionicHistory.clearHistory();
    }

    $scope.showURL = function (which) {
        if(which == 1) {
            
            window.open(appConfiguration.privacyPolicyUrl, '_blank');
        }
            
        else if(which ==2)
            window.open(appConstants.app.helpDeskUrl, '_blank');

        return false;
    };

    $scope.gotoLoginEmail = function () {
        $state.go("auth.loginEmail");
    }


}]);