controllers.controller('MenuCtrl', ['$scope', '$state', '$stateParams', 'appConstants', 'datacontext', 'session', 'eventService', 'ObjectService', '$log', '$translate', '$ionicPopup', 'AnalyticsService', '$ionicModal', '$timeout', '$sce', 'eventService', '$cordovaInAppBrowser', '$cordovaDialogs', 'PlatformCheck', 'NotifyService', function ($scope, $state, $stateParams, appConstants, datacontext, session, eventService, ObjectService, $log, $translate, $ionicPopup, AnalyticsService, $ionicModal, $timeout, $sce, eventService, $cordovaInAppBrowser, $cordovaDialogs, PlatformCheck, NotifyService) {

    //$scope.poweredBy = "App powered by EventEye.co";

    var participantEntity = null;
    $scope.currentUser = null;

    $scope.checkinCode = "";

    // Qondor Agenda Integration Variables
    var projectId = "";
    var programLoginCode = "";
    var agendaBaseURL = appConstants.app.integrations.agendaBaseURL;

    $scope.$on("$ionicView.beforeEnter", function() {

        participantEntity = datacontext.getCachedProfile(session.getLoggedInParticipantId());
        if (participantEntity) {
            $scope.currentUser = ObjectService.getSimpleObject(e.apiContentTypes.Participant, participantEntity);
        } else {
            $scope.currentUser = {}
        }
        $scope.currentEvent = ObjectService.getSimpleObject(e.apiContentTypes.Event, datacontext.getCachedEventInformation(eventService.getId()));
        $scope.logoImageUrl = $scope.currentEvent.imageUrl;
        if ($scope.currentEvent.moduleInfoPages || $scope.currentEvent.moduleVenueMaps) {
            $scope.customPages = ObjectService.getSimpleObjectArray(e.apiContentTypes.CustomPage, datacontext.getCachedCustomPages())
        } else {
            $scope.customPages = [];
        }
        $scope.showAgenda = (participantEntity.programLoginCode == "" || participantEntity.programLoginCode == undefined) ? false : true;
        configureCheckInCode();

        NotifyService.subscribe($scope, 'notify-eventExited', function eventExited() {
            var participantEntity = null;
            $scope.currentUser = null;
            $scope.currentEvent = null;
            $scope.checkinCode = "";
            $scope.logoImageUrl = null;
            $scope.checkInCodeAvailable = false;
            $scope.checkinCodeImgUrl = null;
            $scope.customPages = null;

            // Qondor Agenda Integration Variables
            var projectId = "";
            var programLoginCode = "";
            var agendaBaseURL = appConstants.app.integrations.agendaBaseURL;
        });

    });

    $scope.$on('$ionicView.enter', function () {

        // Analytics
        if (!ionic.Platform.isWebView()) {
            trackProfileView();
        } else {
            AnalyticsService.startTimer("Menu State Open");
        }
        
        $scope.refreshContent();

        if ($scope.showAgenda) {
            preloadAgenda();
        }
    });

    function preloadAgenda() {
        eventEntity = datacontext.getCachedEventInformation(eventService.getId());
        var eventInformation = ObjectService.getSimpleObject(e.apiContentTypes.Event, eventEntity);

        participantEntity = datacontext.getCachedProfile(session.getLoggedInParticipantId());
        var participant = ObjectService.getSimpleObject(e.apiContentTypes.Profile, participantEntity);

        projectId = eventInformation.integrationEventId;
        programLoginCode = participant.programLoginCode;

        agendaBaseURL = (eventInformation.integrationApiUrl != "") ? eventInformation.integrationApiUrl : agendaBaseURL;

        var target = "_blank";
 
        var options = "location=no,hidden=yes";
    
        inAppBrowserRef = cordova.InAppBrowser.open(agendaBaseURL + "projectId=" + projectId + "&programLoginCode=" + programLoginCode, target, options);
    }

    function configureCheckInCode() {
        if ($scope.currentUser.checkInCode && $scope.currentUser.checkInCode != "") {
            var checkinCode = $scope.currentUser.checkInCode;
            $scope.checkInCodeAvailable = true;

            if (checkinCode.startsWith("http")) {
                // Check-in code Image Format
                $scope.checkinCodeImgUrl = checkinCode;
            } else {
                // Check-in code number format
                $scope.checkinCode = checkinCode;
            }

        } else {
            $scope.checkinCodeImgUrl = "";
            $scope.checkInCodeAvailable = false;
        }
    }

    // TICKET MODAL // 

    $ionicModal.fromTemplateUrl('ticket_modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.modal = modal;
        //modal.show();
    });

    $scope.openModal = function () {
        $scope.modal.show();
    };

    $scope.closeModal = function () {
        $scope.modal.hide();
    };

    // Cleanup the modal when we're done with it!
    $scope.$on('$destroy', function () {
        $scope.modal.remove();
    });

    // Execute action on hide modal
    $scope.$on('modal.hidden', function () {
        // Execute action
    });

    // Execute action on remove modal
    $scope.$on('modal.removed', function () {
        // Execute action
    });


    $scope.$on('$ionicView.leave', function (e) {
        if (ionic.Platform.isWebView()) {
            trackProfileView();
        }
    });

    $scope.openQondorAgenda = function () {
        eventEntity = datacontext.getCachedEventInformation(eventService.getId());
        var eventInformation = ObjectService.getSimpleObject(e.apiContentTypes.Event, eventEntity);

        participantEntity = datacontext.getCachedProfile(session.getLoggedInParticipantId());
        var participant = ObjectService.getSimpleObject(e.apiContentTypes.Profile, participantEntity);
        // GRUPPE 1: 2253e99d-1a49-40fa-903c-11013da31dfe
        // GRUPPE 2: ec4f1405-7777-4576-a3db-c3189b15ca7b
        projectId = eventInformation.integrationEventId;
        programLoginCode = participant.programLoginCode;
        //$scope.agendaURL = $sce.trustAsResourceUrl(agendaBaseURL + "projectId=" + projectId + "&programLoginCode=" + programLoginCode);
        //console.log(eventInformation);
        agendaBaseURL = (eventInformation.integrationApiUrl != "") ? eventInformation.integrationApiUrl : agendaBaseURL;
        

        var options = "location=no,hidden=no,closebuttoncaption=Close Agenda";
        //projectId = "debug";
        //console.log(programLoginCode);
        if (projectId == "" || programLoginCode == "") {
            $cordovaDialogs.alert("Your Agenda is not available at the moment", "Agenda");
        } else {
            //console.log("Opening: " + agendaBaseURL + "projectId=" + projectId + "&programLoginCode=" + programLoginCode);
            //$cordovaInAppBrowser.open(agendaBaseURL + "projectId=" + projectId + "&programLoginCode=" + programLoginCode, '_blank', options);
            
            if (PlatformCheck.isDevice()) {
                cordova.InAppBrowser.open(agendaBaseURL + "projectId=" + projectId + "&programLoginCode=" + programLoginCode, '_blank', options);
                //window.open(agendaBaseURL + "projectId=" + projectId + "&programLoginCode=" + programLoginCode, '_blank', options);
            } else {
                window.open(agendaBaseURL + "projectId=" + projectId + "&programLoginCode=" + programLoginCode, '_self', options);
            }
        }


    }

    function trackProfileView() {

        var eventProperties = {
            "State Name": "Menu"
        };
        AnalyticsService.trackEvent("Menu State Open", eventProperties);
    }


    function sameEvent() {
        
        if ($scope.loadedForEvent != eventService.getId()) {
            return false;
            //currentEvent = ObjectService.getSimpleObject(e.apiContentTypes.Event, datacontext.getCachedEventInformation(eventService.getId()));
        } else {
            return true;
        }
    }

    $scope.refreshContent = function (forced) {



        // Call API to get updated content

        datacontext.getProfile().then(function () {

            // Updated user profile successfully received

            var participantEntity = datacontext.getCachedProfile(session.getLoggedInParticipantId());

            $log.debug("RESULT RESULT: " + participantEntity);

            $scope.currentUser = ObjectService.getSimpleObject(e.apiContentTypes.Participant, participantEntity);

        }).catch(function (err) {

            $log.debug("Fetch participant failed: " + err);

        }).then(function () {

            datacontext.sync(forced).then(function () {

                $log.debug("Successfully synced (menuController.js)");

                var currentEvent = ObjectService.getSimpleObject(e.apiContentTypes.Event, datacontext.getCachedEventInformation(eventService.getId()));

                if (currentEvent.isComplete) {
                    $scope.currentEvent = currentEvent;
                }

                if ($scope.currentEvent.moduleInfoPages || $scope.currentEvent.moduleVenueMaps) {
                    $scope.customPages = ObjectService.getSimpleObjectArray(e.apiContentTypes.CustomPage, datacontext.getCachedCustomPages())
                } else {
                    $scope.customPages = [];
                }

            }).catch(function (err) {

                $log.debug("sync failed: " + err);
            });
        }).finally(function () {
            configureCheckInCode();
            // Tell the refresher the refresh is complete
            $scope.$broadcast('scroll.refreshComplete');

        });

    }

    $scope.exitEvent = function () {

        NotifyService.notify('notify-eventExited');

        var token = session.getToken();
        var userParticipantId = session.getLoggedInParticipantId();
        var eventToken = session.getEventToken;
        var currentEventId = '';

        datacontext.clearData();

        session.create('', token, true, userParticipantId, eventToken);

        eventService.create(currentEventId);

        datacontext.loadData();

        $state.go("multi.eventList");
    }

    $scope.logout = function () {
        $scope.showConfirm();
    }

    // A confirm dialog
    $scope.showConfirm = function () {

        $translate.onReady().then(function () {
            var confirmPopup = $ionicPopup.confirm({
                title: $translate.instant('MULTI.DIALOGS.SIGN_OUT_CONFIRMATION.TITLE'),
                cssClass: 'exitConfirm',
                template: $translate.instant('MULTI.DIALOGS.SIGN_OUT_CONFIRMATION.BODY'),
                okText: $translate.instant('MULTI.DIALOGS.SIGN_OUT_CONFIRMATION.OK_BUTTON'),
                okType: 'button-calm',
                cancelText: $translate.instant('MULTI.DIALOGS.SIGN_OUT_CONFIRMATION.CANCEL_BUTTON'),
                cancelType: 'button-assertive'
            });
            confirmPopup.then(function (res) {
                if (res) {
                    session.logout();
                } else {
                    //$log.debug('You are not sure');
                }
            });

        });

    };

    $scope.poweredByClicked = function () {
        
        var currentEvent = ObjectService.getSimpleObject(e.apiContentTypes.Event, datacontext.getCachedEventInformation(eventService.getId()));
        
        var url = "http://info.eventeye.co/request-more-information";

        var currentLanguage = currentEvent.language.substring(0,2);
        console.log(currentLanguage);
        if (currentLanguage == "nb" || currentLanguage == "sv") {
            url = "http://info.eventeye.co/informasjon-om-eventapp";
        }

        if (PlatformCheck.isDevice()) {
            window.open(url, '_blank', 'location=yes');
        } else {
            window.open(url, '_self', 'location=yes');
        }
    }

}]);