controllers.controller('MultiEventCtrl', ['$scope', '$state', '$stateParams', 'appConstants', 'datacontext', 'session', '$ionicPopup', 'events', '$log', 'eventService', 'toaster', 'ObjectService', '$translate', '$ionicHistory', 'AnalyticsService', 'CustomColorService', '$ionicActionSheet', '$ionicLoading', 'PlatformCheck', 'AppService', function ($scope, $state, $stateParams, appConstants, datacontext, session, $ionicPopup, events, $log, eventService, toaster, ObjectService, $translate, $ionicHistory, AnalyticsService, CustomColorService, $ionicActionSheet, $ionicLoading, PlatformCheck, AppService) {

    //Fetching the constants for title and footer... 
    $scope.appTitle = appConstants.app.name;

    //$scope.poweredBy = "App powered by EventEye.co";

    //var participantEntity = {};
    //$scope.currentUser = [];
    $scope.events = null;
    $scope.upcomingEvents = [];
    $scope.pastEvents = [];
    $scope.isContainerApp = appConstants.app.isContainerApp;


    $scope.$on('$ionicView.beforeEnter', function () {

        CustomColorService.updateColorScheme();

        $translate.use(appConstants.app.preferredLanguage);
        moment.locale(appConstants.app.preferredLanguageShort.substring(0, 2));
        
        $scope.events = ObjectService.getSimpleObjectArray(e.apiContentTypes.Event, datacontext.getCachedEvents());
        $scope.refreshContent();
        catagorizeEvents($scope.events);

    });

    $scope.$on('$ionicView.enter', function () {

        // Analytics
        if (!ionic.Platform.isWebView()) {
            trackProfileView();
        } else {
            AnalyticsService.startTimer("Event List State Open");
        }

        $log.debug("Entering");

        $ionicHistory.clearHistory();

        $scope.refreshContent();
    });

    $scope.$on('$ionicView.leave', function (e) {
        if (ionic.Platform.isWebView()) {
            trackProfileView();
        }
    });

    function trackProfileView() {
        var eventProperties = {
            "State Name": "Event List"
        };
        AnalyticsService.trackEvent("Event List State Open", eventProperties);
    }

    // No events explanation dialogue
    $scope.showExplanationDialogue = function () {
        $translate.onReady().then(function () {
            var explanationPopup = $ionicPopup.show({
                title: $translate.instant('MULTI.DIALOGS.NO_EVENTS_EXPLANATION.TITLE'),
                template: $translate.instant('MULTI.DIALOGS.NO_EVENTS_EXPLANATION.BODY'),
                buttons: [{
                        text: $translate.instant('MULTI.DIALOGS.NO_EVENTS_EXPLANATION.OK_BUTTON'),
                        type: 'button-positive'
                    },
                    {
                        text: $translate.instant('MULTI.DIALOGS.NO_EVENTS_EXPLANATION.SUPPORT_BUTTON'),
                        type: 'button-dark',
                        onTap: function (e) {
                            window.open(appConstants.app.helpDeskUrl, '_blank');
                        }
                    }
                ]
            });
        });
    }


    // A confirm dialog
    $scope.showConfirm = function () {

        $translate.onReady().then(function () {
            var confirmPopup = $ionicPopup.confirm({
                title: $translate.instant('MULTI.DIALOGS.SIGN_OUT_CONFIRMATION.TITLE'),
                cssClass: 'exitConfirm',
                template: $translate.instant('MULTI.DIALOGS.SIGN_OUT_CONFIRMATION.BODY'),
                okText: $translate.instant('MULTI.DIALOGS.SIGN_OUT_CONFIRMATION.OK_BUTTON'),
                okType: 'button-calm',
                cancelText: $translate.instant('MULTI.DIALOGS.SIGN_OUT_CONFIRMATION.CANCEL_BUTTON'),
                cancelType: 'button-assertive'
            });
            confirmPopup.then(function (res) {
                if (res) {
                    session.logout();
                } else {
                    //$log.debug('You are not sure');
                }
            });

        });

    };

    $scope.logout = function () {
        $scope.showConfirm();
    }



    $scope.refreshContent = function () {

        // Call sync to get updated content

        AppService.hasConnection().success(function() {
            datacontext.getEvents(true).then(function () {

                $debug.log("Eventlist update Completed (multieventcontroller.js)");
    
                // Update list from cache

            }).catch(function (err) {
    
                $debug.log("Fetch eventinfo failed: " + err);
    
            }).finally(function () {

                $scope.events = ObjectService.getSimpleObjectArray(e.apiContentTypes.Event, datacontext.getCachedEvents());
                //Catagorize events into pastEvents and upcomingEvents....
                catagorizeEvents($scope.events);
    
                // Tell the refresher the refresh is complete
                $scope.$broadcast('scroll.refreshComplete');
    
            });
        }).error(function() {
            $scope.$broadcast('scroll.refreshComplete');
        });

        /*
        // DEPRECIATED CODE
        
        .then(function () {
            datacontext.getProfile().then(function () {

                $log.debug("Successfully fetched user profile (multieventcontroller.js)");


            }).catch(function (err) {

                $log.debug("Fetch participant failed: " + err);
            }).finally(function () {
                //Depreciated:
                //var participantEntity = datacontext.getCachedProfile(session.getLoggedInParticipantId()); //MISSED A SEMI-COLON. ADDED
                //$scope.currentUser = ObjectService.getSimpleObject(e.apiContentTypes.Participant, participantEntity);
                //$log.debug("USER: " + JSON.stringify(participantEntity));
            });
        })*/


    }


    ///////////////////////
    // Add event by code //
    ///////////////////////

    $scope.lookupEvent = function(eventCode) {

        $translate.onReady().then(function () {
            // Validate input
            if (!eventCode) {
                // No code
                
                    $ionicPopup.alert({
                        template: $translate.instant('MULTI.DIALOGS.CODE_VALIDATION_ERROR.BODY'),
                        title: $translate.instant('MULTI.DIALOGS.CODE_VALIDATION_ERROR.TITLE')
                    });

            } else {
                // Valid
                
                // Show spinner
                $ionicLoading.show({
                    template: '<ion-spinner></ion-spinner>'
                });

                // Call Endpoint
                var verification = session.verifyEventCode(eventCode);
                verification.success(function (data, status) {
                    $log.debug("Event Code Verified!");
                    
                    if (eventAlreadyAdded(data.id)) {
                        $ionicLoading.hide();

                        $ionicPopup.alert({
                            title: $translate.instant('MULTI.DIALOGS.CODE_ALREADY_REGISTERED.TITLE'),
                            template: $translate.instant('MULTI.DIALOGS.CODE_ALREADY_REGISTERED.BODY1') + data.title + $translate.instant('MULTI.DIALOGS.CODE_ALREADY_REGISTERED.BODY2')
                        });
                    } else {
                        $ionicLoading.hide();

                    // Show Dialogue
                        var confirmEnterEventPopup = $ionicPopup.confirm({
                        title: "\"" + data.title + "\"",
                        template: $translate.instant('MULTI.DIALOGS.CODE_CONFIRM_JOIN.BODY'),
                        okText: $translate.instant('MULTI.DIALOGS.CODE_CONFIRM_JOIN.OK_BUTTON'),
                        cancelText: $translate.instant('MULTI.DIALOGS.CODE_CONFIRM_JOIN.CANCEL_BUTTON')
                        });
                    
                        confirmEnterEventPopup.then(function(res) {
                        if(res) {
                            $state.go("multi.createProfile", {eventCode: eventCode, currentEvent: data});
                        } else {

                        }
                        });
                    }

                    
                    
                    
                    
                    
                    

                }).error(function (response) {
                    //$scope.errorMessage = response.message;
                    $ionicPopup.alert({
                        title: $translate.instant('MULTI.DIALOGS.CODE_NOT_FOUND.TITLE'),
                        template: $translate.instant('MULTI.DIALOGS.CODE_NOT_FOUND.BODY1') + eventCode + $translate.instant('MULTI.DIALOGS.CODE_NOT_FOUND.BODY2')
                    });
                    /* $translate.onReady().then(function () {
                        $scope.loginButtonsDisabled = false;
                        $ionicLoading.hide();
                        $cordovaDialogs.alert($translate.instant('AUTH.LOGIN_EMAIL.MESSAGES.GENERAL_ERROR.BODY'), $translate.instant('AUTH.LOGIN_EMAIL.MESSAGES.GENERAL_ERROR.TITLE'));
                        $log.debug("Error: " + response);
                    }); */

                    // Hide spinner
                    $ionicLoading.hide();
                    });
                // Handle response

                
            }
        });
    }


    function eventAlreadyAdded(eventId) {
        var eventFound = false;
        
        for(var i = 0; i<$scope.events.length; i++) {
            var event = $scope.events[i];
            if (event.id == eventId) {
                eventFound = true;
            }
        }

        return eventFound;
    }





    /***********************/
    /* THIS METHOD CATAGORIZE EVENTS INTO UPCOMING OR PAST..*/
    /*********************/
    var catagorizeEvents = function (allEvents) {
        var today = moment.utc();

        //clear upComingEvents and pastEvents arrays...
        $scope.upcomingEvents = [];
        $scope.pastEvents = [];

        $translate.onReady().then(function () {

            angular.forEach(allEvents, function (event) {
                //$log.debug("event:"+event.startTime);
                /*Check if startDate if before or after today 
                If the start date is already passed...also check the endTime to see if it hadnot past today or not....
                */
                //getting the number of days difference between endDate....
                var daysDiffEndDate = Math.floor((today - event.endTime) / 86400000);
                var daysDiffStartdate = Math.floor((today - event.startTime) / 86400000);
                //if startDiff is positive and endDiff is negative ....that means its going on...

                if (daysDiffStartdate >= 0 && daysDiffEndDate <= 0) //if its going on then only......
                    event['timeValue'] = $translate.instant('MULTI.TODAY');
                else if (daysDiffEndDate > 0) //if its past then Find difference in end date.....
                    event['timeValue'] = moment(moment(event.endTime).format('YYYY-MM-DD HH:mm:ss')).fromNow();
                else //or show difference...
                    event['timeValue'] = moment(moment(event.startTime).format('YYYY-MM-DD HH:mm:ss')).fromNow();


                $log.debug("Start Diff: " + daysDiffStartdate + " ,End Diff: " + daysDiffEndDate);

                var difference = Math.floor(today - event.startTime);

                //$log.debug("Difference:"+difference);
                if (daysDiffEndDate > 0) //IF IT IS PAST EVENT......
                    $scope.pastEvents.push(event);
                if (daysDiffEndDate <= 0 && daysDiffStartdate >= 0) //IF THE EVENT IS GOING ON...
                    $scope.upcomingEvents.push(event);
                if (daysDiffStartdate < 0) //IF THE EVENT IS IN FUTURE.....
                    $scope.upcomingEvents.push(event);
            });
        });

        // $scope.upcomingEvents = events;
        //    $scope.pastEvents = events;
    } //END OF catagorizeEvents....

    $scope.eventClicked = function (event) {

        datacontext.clearData();

        var token = session.getToken();
        //if (appConstants.app.isContainerApp) {
            var userParticipantId = event.participantId;
        //} else {
        //    var userParticipantId = session.getLoggedInParticipantId();
        //}
        var eventToken = event.authToken;
        var currentEventId = event.id;

        session.create('', token, true, userParticipantId, eventToken);

        eventService.create(currentEventId);

        //datacontext.loadData();

        if (ionic.Platform.isWebView()) {
            trackProfileView();
        }

        $state.go("auth.sync");

    }

    $scope.showHelpMenu = function () {
        $translate.onReady().then(function () {

            // Show the action sheet
            var hideSheet = $ionicActionSheet.show({
                buttons: [{
                    text: $translate.instant('AUTH.SIGNIN_VERIFICATION.SUPPORT.OPTIONS.FAQ')
                }, {
                    text: $translate.instant('AUTH.SIGNIN_VERIFICATION.SUPPORT.OPTIONS.CONTACT_SUPPORT')
                }],
                titleText: $translate.instant('AUTH.SIGNIN_VERIFICATION.SUPPORT.ACTION_MENU_TITLE'),
                cancelText: $translate.instant('AUTH.SIGNIN_VERIFICATION.SUPPORT.OPTIONS.CANCEL'),
                cancel: function () {
                    // add cancel code..
                },
                buttonClicked: function (index) {
                    switch (index) {
                        case 0:
                            {
                                // FAQ: 
                                window.open('https://eventeye.freshdesk.com/support/solutions/folders/35000091301', '_blank');
                                break;
                            }
                        case 1:
                            {
                                // Contact Support
                                window.open(appConstants.app.helpDeskUrl, '_blank');
                                break;
                            }
                    }
                    return true;
                }
            });
        });

    };

    $scope.poweredByClicked = function () {
        var url = "http://info.eventeye.co/request-more-information";
        if (PlatformCheck.isDevice()) {
            window.open(url, '_blank', 'location=yes');
        } else {
            window.open(url, '_self', 'location=yes');
        }
    }

}]);