controllers.controller('OpenQuestionAnswerFeedCtrl', ['$scope', '$rootScope', '$state', 'datacontext', '$ionicScrollDelegate', 'PushService', '$stateParams', '$log', '$cordovaToast', 'PollService', '$ionicLoading', 'appConstants', '$cordovaDialogs', '$interval', 'AppService', '$translate', 'FlagContentService', 'AnalyticsService', '$ionicHistory', function ($scope, $rootScope, $state, datacontext, $ionicScrollDelegate, PushService, $stateParams, $log, $cordovaToast, PollService, $ionicLoading, appConstants, $cordovaDialogs, $interval, AppService, $translate, FlagContentService, AnalyticsService, $ionicHistory) {

    var refreshInterval = 5000;
    var timer;
    var infiniteScrollInterval = 20;
    //var answersLoaded = 0;
    var question = [];
    var revisionDate = "";

    $scope.selected = [];
    $scope.noOfAnswers = 1; //this variable will set how many answers can a question have....
    $scope.firstTime = true; //This is to load a class for first time only for animation...
    $scope.answersToShow = [];

    //make it by default true...
    $scope.data={connection:true};
    
    $scope.myStyles = [];
    //This variable is used to show if any new answers are available or not....
    $scope.isAnswerAvailable = false;

    $scope.loadNewAnswers = function () {
            $scope.refreshContent();

        } //end of loadNEwAnswers...

    $scope.$on("$ionicView.beforeEnter", function() {
        // If navigation history is empty (ie. browser refresh) --> reset state to parent tab
        if ($ionicHistory.viewHistory().currentView.backViewId == null) {
            $ionicHistory.nextViewOptions({
                disableAnimate: true,
                disableBack: true
            });
            $state.go("tabs.menu");
        }       
    });

    $scope.$on('$ionicView.enter', function (e) {

        // Start timer to call for new posts 
        $scope.refreshContent();
        
        // Analytics
        if (!ionic.Platform.isWebView()) {
            trackProfileView();
        } else {
            AnalyticsService.startTimer("Open Question Answer Feed State Open");
        }

         //CHECKING FOR INTERNET CONNECTION...
        AppService.hasConnection().success(function(){
            //console.log("has connection");
            $scope.data={connection:true};
        }).error(function(err){
            //console.log("no connection");
            $scope.data={connection:false};
        });

        


        // FOR DEBUGGING ONLY:
        //$scope.pollData = pollData.data;
        /*DEMO DATA..*/
        /*
        $scope.openAnswerPollData = {
            "sourceType": 3,
            "id": 1,
            "text": "This is My Question",
            "hasAnswer": true / false,
            "answers": [{
                "id": 1,
                "firstName": "Igor",
                "lastName": "Boky",
                "text": "Answer by Mr Igor...",
                "date": "2016-01-18T01:40:53.179Z"
                    }, {
                "id": 2,
                "firstName": "Sijan",
                "lastName": "Gurung",
                "text": "Answer is the opposite of Question",
                "date": "2016-01-17T11:40:53.179Z"
                    }, {
                "id": 3,
                "firstName": "Fredrik",
                "lastName": "Hoel",
                "text": "This is my fully descriptive answer, because i tend to give the answer in the complete terms and conditions. Basically, I do not understand the question.",
                "date": "2016-01-10T11:40:53.179Z"
                    }, {
                "id": 4,
                "firstName": "Ane",
                "lastName": "Monsoon",
                "text": "Answer is the only thing i dont know about.Ho Ho Ho !",
                "date": "2016-01-18T11:40:53.179Z"
                    }],
            "updatedAt": "2015-10-20T11:40:53.179Z"
        };
        
        */


        $translate.onReady().then(function () {
            $ionicLoading.show({
                template: $translate.instant('NAVIGATION.OPENANSWERPOLL_ANSWER.LOADING')
            });

            // refreshContent(openTextPoll.data);
            $ionicScrollDelegate.resize();
            $ionicLoading.hide();

            //FOR DEBUG PURPOSE ONLY...REMOVE IT LATER....
        });

    });

    $scope.$on('$ionicView.leave', function () {
        if (angular.isDefined(timer)) {
            $interval.cancel(timer);
            timer = undefined;
        }
        
        if (ionic.Platform.isWebView()) {
            trackProfileView();
        }

    });
    
    function trackProfileView() {
        var eventProperties = {
            "State Name": "Open Question Answer Feed",
            "Open Question id": $scope.questionId,
            "Open Question title": $scope.questionText 
        };
        AnalyticsService.trackEvent("Open Question Answer Feed State Open", eventProperties);
    }

    function startTimer() {
        // Start interval refresh
        timer = $interval(function () {
            $log.debug("Refreshing!");
            //Set the firstTime to be false ..
            $scope.firstTime = false; //this is to disable the animation..
            getNewAnswersCount();
        }, refreshInterval);
    }

    function getNewAnswersCount() {

        if (revisionDate != "") {
            var answerCountPromise = PollService.getOpenQuestionNewAnswersCount($stateParams.openQuestionItemId, revisionDate);

            answerCountPromise.success(function (data, status) {

                $log.debug("New count received: " + data.count);
                //revisionDate = data.revisionDate;

                if (data.count > 0) {
                    $scope.isAnswerAvailable = true;
                }

            }).error(function () {
                $log.debug("Get Count error");
            });
        }



    }

    $scope.loadMore = function () {
        //var answersLoadedBeforeLoop = answersLoaded;

        var answersAvailable = question.answers.length;

        //console.log("Answers available: " + answersAvailable);

        var answersToLoad = ($scope.answersToShow.length + infiniteScrollInterval) <= answersAvailable ? infiniteScrollInterval : (answersAvailable - $scope.answersToShow - 1);
        //console.log("answerstoload: " + answersToLoad);

        for (var i = 0; i < answersToLoad; i++) {
            $scope.answersToShow.push(question.answers[i]);
            question.answers.splice(i, 1);
            //answersLoaded++;
        }

        $scope.$broadcast('scroll.infiniteScrollComplete');
    }
    
    

    $scope.moreAnswersCanBeLoaded = function () {
        try {
            var answersAvailable = question.answers.length;
            if (($scope.answersToShow.length >= answersAvailable) ||  (answersAvailable < infiniteScrollInterval)) {
                return false;
            }
            return true;
        } catch (e) {
            return false;
        }

    }

    $scope.refreshContent = function refreshContent() {

        //console.log("openQuestionData: " + JSON.stringify(openQuestionData));

        $ionicLoading.show({
            template: '<ion-spinner></ion-spinner>'
        });

        if (angular.isDefined(timer)) {
            $interval.cancel(timer);
            timer = undefined;
        }

        // HTTP Call to get active polls
        var openQuestionOpenPromise = PollService.getOpenQuestionDetails($stateParams.openQuestionItemId);

        openQuestionOpenPromise.success(function (data, status) {
            $scope.data={connection:true};
            revisionDate = getDateInUtcFormat(Date());
            //console.log("DATA: " + JSON.stringify(data));

            // FOR DEBUGGING:
            //var json = "{\"hasAnswer\":true,\"answers\":[{\"text\":\"Spørsmål 1\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 2\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 3\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 4\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 5\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 6\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 7\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 8\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 9\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 10\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 11\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 12\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 13\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 14\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 15\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 16\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 17\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 18\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 19\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 20\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 21\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 22\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 23\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 24\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 25\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 26\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 27\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 28\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 29\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 30\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 31\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 32\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 33\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 34\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 35\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 36\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 37\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 38\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 39\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 40\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 41\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 42\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 43\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 44\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 45\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 46\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 47\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"},{\"text\":\"Spørsmål 48\",\"date\":\"2016-01-21T10:50:38.206Z\",\"firstName\":\"Fredrik\",\"lastName\":\"Hoel\",\"id\":1,\"updatedAt\":\"2016-01-21T10:51:16.696Z\"}],\"text\":\"Hva synes du om lunchen?\",\"answersCount\":1,\"id\":1,\"updatedAt\":\"2016-01-21T10:50:38.206Z\"}";
            //data = JSON.parse(json);

            question = data;

            $scope.questionText = data.text;
            
            $scope.questionId = data.id;
            
            $scope.answersToShow = question.answers;
/*
            var answersToAdd = (question.answers.length >= infiniteScrollInterval) ? infiniteScrollInterval : question.answers.length;

            
            // Set new data
            $scope.answersToShow = [];
            for (var i = 0; i < answersToAdd; i++) {

                console.log("New data entry:( " + i + ") " + question.answers[i].text);
                $scope.answersToShow.push(question.answers[i]);
                question.answers.splice(i, 1);
                //answersLoaded = i;
            }
            console.log("NEW ARRAY: " + $scope.answersToShow);

*/
            // Scroll to top
            $ionicScrollDelegate.scrollTop();

            // Hide loading indicator
            $ionicLoading.hide();

            // No new answers available
            $scope.isAnswerAvailable = false;

            // Start timer to look for updates
            startTimer();

        }).error(function () {
            $ionicLoading.hide();
            $scope.data={connection:false};

            startTimer();
        });




    }

    $scope.flagContent = function (answerId) {
        FlagContentService.flagContent("oq", answerId);
    }

    function getDateInUtcFormat(date) {
        if (typeof date === "string")
            date = new Date(date);

        //var copy = new Date(date.getTime() - (date.getTimezoneOffset() * 60000));
        //return JSON.stringify(copy).slice(1, -1);
        return JSON.stringify(date).slice(1, -1);
    }


}]);