controllers.controller('OpenQuestionCtrl', ['$scope', '$state', '$log', 'AppService', '$ionicScrollDelegate', '$ionicLoading', 'PollService', '$interval', 'AnalyticsService', '$ionicHistory', function ($scope, $state, $log, AppService, $ionicScrollDelegate, $ionicLoading, PollService, $interval, AnalyticsService, $ionicHistory) {

    var refreshInterval = 5000;
    var timer;
    $scope.data={connection:true};

    $scope.$on("$ionicView.beforeEnter", function() {
        // If navigation history is empty (ie. browser refresh) --> reset state to parent tab
        if ($ionicHistory.viewHistory().currentView.backViewId == null) {
            $ionicHistory.nextViewOptions({
                disableAnimate: true,
                disableBack: true
            });
            $state.go("tabs.menu");
        }       
    });
    
    $scope.$on('$ionicView.enter', function (e) {
        
        // Analytics
        if (!ionic.Platform.isWebView()) {
            trackProfileView();
        } else {
            AnalyticsService.startTimer("Open Question List State Open");
        }

         //CHECKING FOR INTERNET CONNECTION...
        AppService.hasConnection().success(function(){
            //console.log("has connection");
            $scope.data={connection:true};
        }).error(function(err){
            //console.log("no connection");
            $scope.data={connection:false};
        });

        $ionicScrollDelegate.resize();

        // Refresh / Load polls
        $scope.refreshContent(true);

        // Start interval refresh
        timer = $interval(function () {
            $log.debug("Refreshing!");
            $scope.refreshContent(true);
        }, refreshInterval);

    });

    $scope.$on('$ionicView.leave', function () {
        if (angular.isDefined(timer)) {
            $interval.cancel(timer);
            timer = undefined;
        }
        
        if (ionic.Platform.isWebView()) {
            trackProfileView();
        }

    });
    
    function trackProfileView() {
        var eventProperties = {
            "State Name": "Open Question List"
        };
        AnalyticsService.trackEvent("Open Question List State Open", eventProperties);
    }

    $scope.checkAnswered = function (openQuestionItem) {

        //console.log(openQuestionItem.hasAnswer);
        
        if (!openQuestionItem.hasAnswer) {
            $log.debug("GOING TO DETAILS ID: " + openQuestionItem.id);
            $state.go('tabs.openQuestionDetails', {
                openQuestionItemId: openQuestionItem.id
            });
        } else {
            $log.debug("GOING TO ANSWER FEED ID: " + openQuestionItem.id);
            $state.go('tabs.openQuestionAnswerFeed', {
                openQuestionItemId: openQuestionItem.id
            });
        }


    }

    $scope.refreshContent = function (hideLoadingMessage) {
        if (hideLoadingMessage !== true) {

            $ionicLoading.show({
                template: '<ion-spinner></ion-spinner>'
            });

        }


        // HTTP Call to get active polls
        var openQuestionPromise = PollService.getOpenQuestions();

        openQuestionPromise.success(function (data, status) {
            // $log.debug(JSON.stringify(data));
            $scope.data={connection:true};
            $scope.openQuestions = data;
            $ionicLoading.hide();
        }).error(function () {
            
            $ionicLoading.hide();
            $scope.data={connection:false};
        });

    }



}]); //End of controller...