controllers.controller('OpenQuestionDetailsCtrl', ['$scope', '$rootScope', '$state', 'datacontext', '$ionicScrollDelegate', 'PushService', '$stateParams', '$log', '$cordovaToast', 'PollService', '$ionicLoading', 'appConstants', '$cordovaDialogs', '$interval', 'AppService', '$translate', 'openQuestionData', 'AnalyticsService', '$ionicHistory', function ($scope, $rootScope, $state, datacontext, $ionicScrollDelegate, PushService, $stateParams, $log, $cordovaToast, PollService, $ionicLoading, appConstants, $cordovaDialogs, $interval, AppService, $translate, openQuestionData, AnalyticsService, $ionicHistory) {


    $scope.firstTime = true; //This is to load a class for first time only for animation...
    //should be true...first time
    $scope.data = {
        connection: true
    };
    //THIS IS THE TOTAL CHARS THAT ARE ALLOWED AS ANSWER
    $scope.totalCharsAllowed = 140;
    $scope.openQuestionText = {
        text: ""
    };

    $scope.myStyles = [];


    $scope.submitAnswer = function(openQuestionItem) {

        $ionicLoading.show({
            template: '<ion-spinner></ion-spinner>'
        });

        //console.log($scope.openQuestionData.id);

        var postPromise = PollService.postOpenQuestionAnswer($scope.openQuestionData.id, $scope.openQuestionText.text)

        postPromise.success(function(data, status) {
            if (status === 200) {

                // New token received
                $log.debug("Answer submitted");

                $ionicLoading.hide();

                $cordovaDialogs.alert($translate.instant('NAVIGATION.OPENQUESTION_DETAILS.SUBMIT_SUCCESS_MESSAGE.BODY'), $translate.instant('NAVIGATION.OPENQUESTION_DETAILS.SUBMIT_SUCCESS_MESSAGE.TITLE'));

                $state.go("tabs.openQuestionAnswerFeed", {
                    openQuestionItemId: openQuestionItem.id
                });

            }
        }).error(function(data, status) {
            // In case token posting fails.

            $log.debug("Posting Answer ERROR: " + data + " " + status);

            $ionicLoading.hide();

            $cordovaDialogs.alert($translate.instant('NAVIGATION.OPENQUESTION_DETAILS.SUBMIT_ERROR_MESSAGE.BODY'), $translate.instant('NAVIGATION.OPENQUESTION_DETAILS.SUBMIT_ERROR_MESSAGE.TITLE'));

        });

    }

    $scope.$on("$ionicView.beforeEnter", function() {
        // If navigation history is empty (ie. browser refresh) --> reset state to parent tab
        if ($ionicHistory.viewHistory().currentView.backViewId == null) {
            $ionicHistory.nextViewOptions({
                disableAnimate: true,
                disableBack: true
            });
            $state.go("tabs.menu");
        }       
    });

    $scope.$on('$ionicView.enter', function(e) {

        $scope.openQuestionData = openQuestionData.data;

        // Analytics
        if (!ionic.Platform.isWebView()) {
            trackProfileView();
        } else {
            AnalyticsService.startTimer("Open Question Details State Open");
        }

        //CHECKING FOR INTERNET CONNECTION...
        AppService.hasConnection().success(function() {
            //console.log("has connection");
            $scope.data = {
                connection: true
            };
        }).error(function(err) {
            //console.log("no connection");
            $scope.data = {
                connection: false
            };
        });

        //refreshContent();
        

        $ionicScrollDelegate.resize();

    });

    $scope.$on('$ionicView.leave', function(e) {
        if (ionic.Platform.isWebView()) {
            trackProfileView();
        }
    });

    function trackProfileView() {
        var eventProperties = {
            "State Name": "Open Questions Details",
            "Location Map Id": $scope.openQuestionData.id,
            "LocationMap Title": $scope.openQuestionData.text
        };
        AnalyticsService.trackEvent("Open Question Details State Open", eventProperties);
    }

    function refreshContent() {
        if (!$scope.openQuestionData || $scope.openQuestionData == undefined || $scope.openQuestionData == null) {
            $scope.openQuestionData = openQuestionData;
        }

        var polls = PollService.getPolls();

        polls.success(function(data, status) {
            // $log.debug(JSON.stringify(data));
            $scope.data = {
                connection: true
            };
            $scope.openQuestionData = data;
            $ionicLoading.hide();
        }).error(function() {
            $ionicLoading.hide();
            $scope.data = {
                connection: false
            };
        });


    }



}]).directive('myMaxlength', ['$compile', '$log', function($compile, $log) {
    return {
        scope: true,
        restrict: 'A',
        require: 'ngModel',
        link: function(scope, elem, attrs, ctrl) {
            attrs.$set("ngTrim", "false");
            var maxlength = parseInt(attrs.myMaxlength, 10);
            ctrl.$parsers.push(function(value) {
                $log.info("In parser function value = [" + value + "].");
                if (value.length > maxlength) {
                    $log.debug("The value [" + value + "] is too long!");
                    value = value.substr(0, maxlength);
                    ctrl.$setViewValue(value);
                    ctrl.$render();
                    $log.debug("The value is now truncated as [" + value + "].");
                    scope.openQuestionText.text = value;
                }
                return value;
            });
        }
    };
}]);