controllers.controller('ParticipantProfileCtrl', ['$scope', 'participant', '$cordovaInAppBrowser', '$cordovaEmailComposer', '$log', 'FlagContentService', 'AnalyticsService', '$translate', '$ionicHistory', '$state', function($scope, participant, $cordovaInAppBrowser, $cordovaEmailComposer, $log, FlagContentService, AnalyticsService, $translate, $ionicHistory, $state) {
    $scope.participant = participant;

    $scope.$on("$ionicView.beforeEnter", function() {
        // If navigation history is empty (ie. browser refresh) --> reset state to parent tab
        if ($ionicHistory.viewHistory().currentView.backViewId == null) {
            $ionicHistory.nextViewOptions({
                disableAnimate: true,
                disableBack: true
            });
            $state.go("tabs.menu");
        }       
    });

    $scope.$on('$ionicView.enter', function(e) {

        // Analytics
        if (!ionic.Platform.isWebView()) {
            trackProfileView();
        } else {
            AnalyticsService.startTimer("Participant Profile State Open");
        }


    });

    $scope.$on('$ionicView.leave', function(e) {
        if (ionic.Platform.isWebView()) {
            trackProfileView();
        }
    });

    function trackProfileView() {
        var eventProperties = {
            "State Name": "Participant Profile",
            "Participant Id": $scope.participant.id,
            "Participant Name": ($scope.participant.firstName + " " + $scope.participant.lastName)
        };
        AnalyticsService.trackEvent("Participant Profile State Open", eventProperties);
    }

    $scope.openURL = function(url) {

        $translate.onReady().then(function () {

            var closeButtonCaption = $translate.instant('GENERAL.DONE');

            var options = {
                location: 'no',
                toolbar: 'yes',
                enableViewportScale: 'yes',
                closebuttoncaption: closeButtonCaption
            }

            $cordovaInAppBrowser.open(url, '_blank', options)
            .then(function(event) {
                // Success
            }).catch(function(event) {
                // Fail
                $log.debug(event);
            });
        });

    };

    $scope.openMail = function(email) {
        $log.debug("openMail Clicked");
        //$cordovaEmailComposer.isAvailable().then(function () {
        $log.debug("email available");
        var newMail = {
            to: email
        };

        $cordovaEmailComposer.open(newMail).then(null, function() {
            // User cancelled email
        });
        //}, function () {
        //   $log.debug("email not available");
        //});
    };

    $scope.flagContent = function(participantId) {
        FlagContentService.flagContent(e.apiContentTypes.Participant, participantId);
    }

}]);