controllers.controller('PollCtrl', ['$scope', '$rootScope', '$log', 'toaster', 'appConstants', '$ionicLoading', 'PollService', '$state', 'datacontext', '$ionicScrollDelegate', '$stateParams', '$cordovaToast', '$interval', '$translate','AppService','AnalyticsService', '$ionicHistory', function ($scope, $rootScope, $log, toaster, appConstants, $ionicLoading, PollService, $state, datacontext, $ionicScrollDelegate, $stateParams, $cordovaToast, $interval, $translate,AppService, AnalyticsService, $ionicHistory) {

    var refreshInterval = 5000;
    var timer;

    $scope.polls = null;
//by default make it true..so that it wont show the red bar onload....
 $scope.data={connection:true};

    $scope.$on("$ionicView.beforeEnter", function() {
        // If navigation history is empty (ie. browser refresh) --> reset state to parent tab
        if ($ionicHistory.viewHistory().currentView.backViewId == null) {
            $ionicHistory.nextViewOptions({
                disableAnimate: true,
                disableBack: true
            });
            $state.go("tabs.menu");
        }       
    });
    
    $scope.$on('$ionicView.enter', function (e) {
        
        // Analytics
        if (!ionic.Platform.isWebView()) {
            trackProfileView();
        } else {
            AnalyticsService.startTimer("Poll List State Open");
        }

        $ionicScrollDelegate.resize();
        
        //CHECKING FOR INTERNET CONNECTION...
        AppService.hasConnection().success(function(){
            //console.log("has connection");
            $scope.data={connection:true};
        }).error(function(err){
            //console.log("no connection");
            $scope.data={connection:false};
        });

        // Refresh / Load polls
        $scope.refreshContent(true);

        // Start interval refresh
        timer = $interval(function () {
            $log.debug("Refreshing!");
            $scope.refreshContent(true);
        }, refreshInterval);

    });

    $scope.$on('$ionicView.leave', function () {
        if (angular.isDefined(timer)) {
            $interval.cancel(timer);
            timer = undefined;
        }
        
        if (ionic.Platform.isWebView()) {
            trackProfileView();
        }

    });
    
    function trackProfileView() {
        var eventProperties = {
            "State Name": "Poll List"
        };
        AnalyticsService.trackEvent("Poll List State Open", eventProperties);
    }

    $scope.checkAnswered = function (pollItem) {
        $state.go('tabs.pollDetails', {pollItemId: pollItem.id});
    }

    $scope.refreshContent = function (hideLoadingMessage) {
        if (hideLoadingMessage !== true) {
            $translate.onReady().then(function () {
                $ionicLoading.show({
                    template: $translate.instant('NAVIGATION.POLLS.LOADING')
                });
            });
        }


        // HTTP Call to get active polls
        var polls = PollService.getPolls();

        polls.success(function (data, status) {
            // $log.debug(JSON.stringify(data));
                $scope.data={connection:true};
            $scope.polls = data;
            $ionicLoading.hide();
        }).error(function () {
            $ionicLoading.hide();
                $scope.data={connection:false};
        });

    }
    
    

}]);