controllers.controller('ScheduleCtrl', ['$scope', 'datacontext', 'appConstants', '$log', function ($scope, datacontext, appConstants, $log) {

    $scope.scheduleItems = [];
    //This array will hold the current schedules....
    $scope.copyOfSchedulesforHeader = [];
    
    $scope.attendAllSessions = appConstants.app.attendAllSessions;

    $scope.$on('$ionicView.enter', function (e) {
        
        $scope.scheduleItems = datacontext.getCachedScheduleItems();

        //Custom Section Header....
        $scope.addHeaderFunction();

        $scope.refreshContent();
        //$log.debug("Number of speakers: " + $scope.scheduleItems[0].speakers.length);

    });

    $scope.$on('$ionicView.unloaded', function (viewInfo, state) {
        $log.debug('CTRL - $ionicView.unloaded', viewInfo, state);
    });

    $scope.refreshContent = function () {

        // Call sync to get updated content
        datacontext.sync().then(function () {

            $log.debug("Sync Completed (syncController.js)");

            // Update list from cache
            $scope.scheduleItems = datacontext.getCachedScheduleItems();
            //Custom Section Header....
            $scope.addHeaderFunction();
            // Tell the refresher the refresh is complete
            $scope.$broadcast('scroll.refreshComplete');
            
        }).catch(function (err) {
            $log.debug("Fetch data failed. (app.js): " + err);

        });
    }

    //This method is to Add the header....
    $scope.addHeaderFunction = function () {
        $scope.copyOfSchedulesforHeader = []; //resetting it....

        var count = 0;
        for (var c = 0; c < $scope.scheduleItems.length; c++) {

            //TODO: We need to check manually if the post have been deleted or not....so the first condition is for that.. 31.08.2015 .. Sijan
            if (($scope.scheduleItems[c].isDeleted != true)){
                $scope.copyOfSchedulesforHeader[count] = $scope.scheduleItems[c];
                count++;
            }
        }
        $log.debug("Total sessions:" + (count - 1));

        //sort the array here..
        $scope.copyOfSchedulesforHeader.sort(function (a, b) {
            return moment.utc(a.startTime) - moment.utc(b.startTime)
        })
        $scope.copyOfSchedulesforHeader[0].isSectionHeader = true;
        //setting currentKey and nextKey
        var currentKey = moment.utc($scope.copyOfSchedulesforHeader[0].startTime).format('dddd (DD/MM)');
        var nextKey;

        for (var i = 1; i < $scope.copyOfSchedulesforHeader.length; i++) {
            //$log.debug("Current Value:"+moment($scope.copyOfSchedulesforHeader[i].startTime).format('MMMM Do YYYY, h:mm:ss a, dddd') );
            nextKey = moment.utc($scope.copyOfSchedulesforHeader[i].startTime).format('dddd (DD/MM)');
            if (nextKey != currentKey) {
                //different value than previoius.so should be header....
                $scope.copyOfSchedulesforHeader[i].isSectionHeader = true;
                currentKey = nextKey;
                $log.debug("Header:" + currentKey);
            } else {
                $scope.copyOfSchedulesforHeader[i].isSectionHeader = false;
            }
        }

    }
/*
//This method is used if we use autoListDivider directive....
    $scope.dividerFunction = function (key) {
        key = key.replace(/"/g,"");
        var keyOnDateFormat = moment.utc(key).format("dddd (DD/MM)");
        $log.debug("Current Key:" + keyOnDateFormat);
        return keyOnDateFormat;
    }
*/
    $scope.colors = {
        "orange": "rgba(255,166,78,1)",
        "red": "rgba(245,84,68,1)",
        "blue": "rgba(21,81,98,1)",
        "purple": "rgba(129,0,129,1)",
        "yellow": "rgba(241,201,2,1)",
        "pink": "rgba(212,43,164,1)",
        "light-blue": "rgba(43,159,212,1)",
        "light-green": "rgba(54,211,162,1)",
    }

    
    $scope.changeAttendingStatus = function(scheduleItem) {
        $log.debug("Changing Schedule Item for: " + scheduleItem.title);
        $log.debug("Current status: " + scheduleItem.isAttend);
        scheduleItem.isAttend = !scheduleItem.isAttend;
        datacontext.saveNewAttendingStatus(scheduleItem);

    }
    
    
    /*$scope.toggleFavourite = function (schedule) {
        schedule.favourite = !schedule.favourite;
    }*/
}]);