controllers.controller('SpeakerProfileCtrl', ['$scope', 'speaker', '$cordovaInAppBrowser', '$cordovaEmailComposer', '$log', 'AnalyticsService', '$translate', 'datacontext', '$state', '$ionicHistory', function($scope, speaker, $cordovaInAppBrowser, $cordovaEmailComposer, $log, AnalyticsService, $translate, datacontext, $state, $ionicHistory) {

    $scope.speaker = speaker;

/*    seen = []
        json = JSON.stringify(speaker, function (key, val) {
            if (typeof val == "object") {
                if (seen.indexOf(val) >= 0)
                    return
                seen.push(val)
            }
            return val
        }, 0)
        
        console.log(json);*/

    $scope.$on("$ionicView.beforeEnter", function() {
        // If navigation history is empty (ie. browser refresh) --> reset state to parent tab
        //console.log($state.current.name)
        if ($ionicHistory.viewHistory().currentView.backViewId == null) {
            $ionicHistory.nextViewOptions({
                disableAnimate: true,
                disableBack: true
            });
            if ($state.current.name == "tabs.menuSpeakerDetails") {
                $state.go("tabs.menu");
            } else {
                $state.go("tabs.agenda");
            }
        }       
    });
    
    $scope.$on('$ionicView.enter', function(e) {

        // Analytics
        if (!ionic.Platform.isWebView()) {
            $log.debug("App running in browser");
            trackProfileView();
        } else {
            $log.debug("App running in Web View - Starting Timer");
            AnalyticsService.startTimer("Speaker Profile State Open");
        }
        
        $scope.currentState = $state.current.name; 
        $scope.sessions = myArray = _.sortBy(datacontext.getCachedScheduleItemsForSpeaker(speaker.scheduleItemIds), function(dateObj) {
            return new Date(dateObj.startTime);
          });
        
        
        
        

    });

    $scope.$on('$ionicView.leave', function(e) {
        if (ionic.Platform.isWebView()) {
            trackProfileView();
        }
        
    });

    function trackProfileView() {
        $log.debug("Tracking!");
        var eventProperties = {
            "State Name": "Speaker Profile",
            "Speaker Id": $scope.speaker.id,
            "Speaker Name": ($scope.speaker.firstName + " " + $scope.speaker.lastName)
        };
        AnalyticsService.trackEvent("Speaker Profile State Open", eventProperties);
    }

    $scope.openURL = function(url) {
        $translate.onReady().then(function () {

            var closeButtonCaption = $translate.instant('GENERAL.DONE');

            var options = {
                location: 'no',
                toolbar: 'yes',
                enableViewportScale: 'yes',
                closebuttoncaption: closeButtonCaption
            }

            $cordovaInAppBrowser.open(url, '_blank', options)
            .then(function(event) {
                // Success
            }).catch(function(event) {
                // Fail
                $log.debug(event);
            });
        });
    };

    $scope.openMail = function(email) {
        $log.debug("openMail Clicked");
        //$cordovaEmailComposer.isAvailable().then(function () {
        $log.debug("email available");
        var newMail = {
            to: email
        };

        $cordovaEmailComposer.open(newMail).then(null, function() {
            // User cancelled email
        });
        //}, function () {
        //   $log.debug("email not available");
        //});
    };



}]);