controllers.controller('VenueMapCtrl', ['$scope', '$state', 'venueMap', 'datacontext', '$stateParams', '$timeout', '$ionicScrollDelegate', 'ionicToast', '$log', 'AnalyticsService', '$ionicHistory', function ($scope, $state, venueMap, datacontext, $stateParams, $timeout, $ionicScrollDelegate, ionicToast, $log, AnalyticsService, $ionicHistory) {

    $scope.venueMap = null;
    $scope.venueMapTitle = null;
    $scope.counter = 0; //this is to count double tap....
    $scope.currentZoomLevel = 0; //This is to find the current zoom level...


    /* THESE VARIABLE ARE THE MOST IMPORTANT ONE... */
    /**************/

    $scope.zoomInMin = 0.8;
    $scope.zoomInMax = 5;
    $scope.zoomInFactor = 3; // is the actual ratio of how much it should be zoomed at double click

    $scope.$on("$ionicView.beforeEnter", function() {
        // If navigation history is empty (ie. browser refresh) --> reset state to parent tab
        if ($ionicHistory.viewHistory().currentView.backViewId == null) {
            $ionicHistory.nextViewOptions({
                disableAnimate: true,
                disableBack: true
            });
            $state.go("tabs.menu");
        }       
    });

    $scope.$on('$ionicView.enter', function (e) {
        
        

        $scope.counter = 0;
        $scope.venueMap = venueMap;
        $scope.refreshContent(); //Background sync .....
        //       $ionicScrollDelegate.resize();
        $scope.imgUrl = venueMap.imageUrl; //The actual Map image....
        $scope.venueMapTitle = venueMap.title; //Title of the Map PAge.....
        //On start .. zoom it to fit the screen.!!!!
        $ionicScrollDelegate.$getByHandle('zoom-pane').zoomTo(0, true, 0, 0);

        // Analytics
        if (!ionic.Platform.isWebView()) {
            trackProfileView();
        } else {
            AnalyticsService.startTimer("Venue Map State Open");
        }
    });
    
    $scope.$on('$ionicView.leave', function (e) {
        if (ionic.Platform.isWebView()) {
            trackProfileView();
        }
    });
    
    function trackProfileView() {
        var eventProperties = {
            "State Name": "Venue Map",
            "Venue Map Id": venueMap.id,
            "Venue Map Title": venueMap.title
        };
        AnalyticsService.trackEvent("Venue Map State Open", eventProperties);
    }
    
    // THIS METHOD TRACKS SCROLL...USED FOR ZOOMING IN
    /***********/
    $scope.trackScroll = function () {
        //$ionicScrollDelegate.resize();
        var scrollDelegate = $ionicScrollDelegate.$getByHandle('zoom-pane');
        var view = scrollDelegate.getScrollView();
        var scale = view.__zoomLevel;
        //  $log.debug("scroll triggered,, scale:" + scale);
        $scope.currentZoomLevel = scale;
    }

    //THIS METHOD HANDLES DOUBLE TAP...
    /*********************/
    $scope.handleDoubleTap = function (event) {
        //GET THE POSITION VALUE...
        var scrollDelegate = $ionicScrollDelegate.$getByHandle('zoom-pane');
        var position = scrollDelegate.getScrollView();
        var leftPos = position.__lastTouchLeft;
        var TopPos = position.__lastTouchTop - 70;
        //    $log.debug("POSITION LEFT::"+position.__lastTouchLeft);
        //    $log.debug("POSITION TOP::"+position.__lastTouchTop);
        $ionicScrollDelegate.zoomBy($scope.zoomInFactor, true, leftPos, TopPos);
        if ($scope.currentZoomLevel > $scope.zoomInMin) { //IF ITS ALREADY ZOOMED FROM SCROLL....
            $scope.counter = 1;
        }
        $scope.counter++;
        //  $log.debug("Counter::" + $scope.counter);
        //        if($scope.counter  == 5){
        //            ionicToast.show('Double-tap once to zoom-out', 'bottom', false, 2500);    }
        if ($scope.counter > 1) {
            $ionicScrollDelegate.zoomTo(0, true, 0, 0);
            $scope.counter = 0; //resetting to zero ....
        }
    }
    $scope.refreshContent = function (forced) {
        // Call sync to get updated content
        datacontext.sync(forced).then(function () {
            $log.debug("Sync Completed (syncController.js)");
            // Update list from cache
            $scope.venueMap = datacontext.getCachedInfoPage($stateParams.venueMapId)
                // Tell the refresher the refresh is complete
            $scope.$broadcast('scroll.refreshComplete');

        }).catch(function (err) {
            $log.debug("Fetch data failed. (app.js): " + err);
        });
    }
}]);