app.value('jsonResultsAdapter',
    new breeze.JsonResultsAdapter({
        name: "eeJsonResultsAdapter",
        extractResults: function (data) {

            var results = data.results;

            if (!results) throw new Error("Unable to resolve 'results' property");

            // Choose which nodes to parse: ie. results.participants or results.scheduleItems
            return results;
        },

        visitNode: function (node, parseContext, nodeContext) {
            try {
                /*
                 *  Participant parser
                 */
                if (node.is === e.apiContentTypes.Participant) {
                    //console.log("Entity Participant found. Adding ...");

                    return {
                        entityType: "Participant"
                    }
                }
                
                else if (node.is == e.apiContentTypes.Profile) {
                    //console.log("Entity Profile found. Adding ...");
                    
                    return {
                        entityType: "Profile"
                    }
                }


                /*
                 *  ScheduleItem parser
                 */
                else if (node.is === e.apiContentTypes.ScheduleItem) {

                    //console.log("Entity ScheduleItem found. Adding ...");

                    node.trackIds = node.tracks;
                    node.trackId = null;

                    node.room = node.roomId;
                    node.roomId = null;

                    node.speakerIds = node.speakers;
                    node.speakers = [];

                    /*angular.forEach(node.speakerIds, function (speaker) {
                            parseContext.entityManager.createEntity("Speaker", speaker);
                        });*/

                    /*if (!node.track) {
                        node.track = null;
                    }*/
                    
                    //console.log(node.isAttend);

                    return {
                        entityType: "ScheduleItem"
                    }
                }

                /*
                 *  Track parser
                 */
                else if (node.is === e.apiContentTypes.Track) {

                    //console.log("Entity Track found. Adding ...");

                    node.scheduleItemIds = node.scheduleItems;
                    node.scheduleItems = null;

                    return {
                        entityType: "Track"
                    }
                }

                /*
                 *  Room parser
                 */
                else if (node.is === e.apiContentTypes.Room) {

                    //console.log("Entity Room found. Adding ...");

                    node.scheduleItemIds = node.scheduleItems;
                    node.scheduleItems = [];

                    /*angular.forEach(node.scheduleItemIds, function (scheduleItem) {
                            parseContext.entityManager.createEntity("ScheduleItem", scheduleItem);
                        });*/

                    return {
                        entityType: "Room"
                    }
                }


                /*
                 * Speaker parser
                 */
                else if (node.is === e.apiContentTypes.Speaker) {

                    //console.log("Entity Speaker found. Adding ...");

                    node.scheduleItemIds = node.scheduleItems;
                    node.scheduleItems = null;

                    return {
                        entityType: "Speaker"
                    }
                }

                /*
                 * Feed - External Content parser
                 */
                else if (node.is === e.apiContentTypes.ExternalPost) {

                    //console.log("Entity Feed External Content found. Adding ...");

                    node.participant = node.participantId;
                    node.participantId = null;

                    node.exhibitor = node.exhibitorId;
                    node.exhibitorId = null;

                    return {
                        entityType: "FeedExternalContent"
                    }
                }


                /*
                 * Info Page parser
                 */
                else if (node.is === e.apiContentTypes.CustomPage) {

                    //console.log("Info Page found. Adding ...");

                    return {
                        entityType: "CustomPage"
                    }
                }
                
                /*
                 * Location Map parser
                 */
                else if (node.is === e.apiContentTypes.LocationMap) {

                    //console.log("Location Map found. Adding ...");

                    return {
                        entityType: "LocationMap"
                    }
                }
                
                /*
                 * Exhibitor parser
                 */
                else if (node.is === e.apiContentTypes.Exhibitor) {
                    return {
                        entityType: "Exhibitor"
                    }    
                }

                /*
                 * Event Info
                 */
                else if (node.is === e.apiContentTypes.Event) {

                    //console.log("Event found. Adding ...");

                    return {
                        entityType: "Event"
                    }
                } else {
                    //console.log("Entity not Recognized by JSON Adapter.");
                }
            } catch(err) {
                //console.log("VISIT NODE ERROR: " + err);
            }

        }
    }));