var directives = angular.module('app.directives', []);

directives.directive('hideTabs', function ($rootScope) {
    return {
        restrict: 'A',
        link: function (scope, element, attributes) {
            scope.$watch(attributes.hideTabs, function (value) {
                $rootScope.hideTabs = value;
            });

            scope.$on('$destroy', function () {
                $rootScope.hideTabs = false;
            });
        }
    };
});

app.directive('fallbackSrc', function () {
    var fallbackSrc = {
        link: function postLink(scope, iElement, iAttrs) {
            iElement.bind('error', function () {
                angular.element(this).attr("src", iAttrs.fallbackSrc);
            });
        }
    }
    
    return fallbackSrc;
});

app.directive('actualSrc', ['appConstants', '$log', function (appConstants, $log) {
    return {
        link: function postLink(scope, element, attrs) {
            attrs.$observe('actualSrc', function (newVal, oldVal) {
                $log.debug("newVal: '" + newVal + "'");
                $log.debug("oldVal" + oldVal);
                if (newVal != undefined && newVal != null && newVal != "") {
                    $log.debug("Setting actualImage");
                    var img = new Image();
                    img.src = attrs.actualSrc;
                    angular.element(img).bind('load', function () {
                        element.attr("src", attrs.actualSrc);
                    });
                } else {
                    var img = new Image();
                    img.src = appConstants.app.defaultProfileImage;
                    angular.element(img).bind('load', function () {
                        element.attr("src", appConstants.app.defaultProfileImage);
                    });
                }
            });

        }
    }
}]);



/*
// THIS DIRECTIVE IS FOR HIDING THE ion-option on ion-list after we click.....

module.directive('clickForClosing', ['$ionicGesture', function($ionicGesture) {
    return {
        restrict: 'A',
        link: function (scope, element, attrs) {
            $ionicGesture.on('tap', function(e){

                // Grab the content
                var content = element[0].querySelector('.item-content');

                // Grab the buttons and their width
                var buttons = element[0].querySelector('.item-options');

                if (!buttons) {
                    $log.debug('There are no option buttons');
                    return;
                }
                var buttonsWidth = buttons.offsetWidth;

                ionic.requestAnimationFrame(function() {
                    content.style[ionic.CSS.TRANSITION] = 'all ease-out .25s';

                    if (!buttons.classList.contains('invisible')) {
                        $log.debug('close');
                        content.style[ionic.CSS.TRANSFORM] = '';
                        setTimeout(function() {
                            buttons.classList.add('invisible');
                        }, 250);                
                    } 
                });     

            }, element);
        }
    };
*/