appServices.filter('hrefToJS', function ($sce, $sanitize, $translate, PlatformCheck) {

    var options = "";
    $translate.onReady().then(function () {

        var closeButtonCaption = $translate.instant('GENERAL.DONE');

        if (PlatformCheck.isDevice()) {
            options = "onClick=\"window.open('$1', '_blank', 'location=no,closebuttoncaption=" + closeButtonCaption + ",toolbar=yes,enableViewportScale=yes')\""
        } else {
            options = "onClick=\"window.open('$1', '_self', 'location=no,closebuttoncaption=" + closeButtonCaption + ",toolbar=yes,enableViewportScale=yes')\""
        }
        //console.log(options);
    });

    return function (text) {
        var regex = /href="([\S]+)"/g;
        var newString = $sanitize(text).replace(regex, options);
        return $sce.trustAsHtml(newString);
    }

});

appServices.filter('createHrefToJSAnchors', function ($sce, PlatformCheck, $translate) {
    return function (str) {
        if (str != null && str != undefined) {

            if (PlatformCheck.isDevice()) {
                return $sce.trustAsHtml(str.replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/(http[^\s]+)/g, "<a class='customAnchor' onClick=\"window.open('$1', '_blank', 'location=no,toolbar=yes,enableViewPortScale=yes')\">$1</a>"));
            } else {
                return $sce.trustAsHtml(str.replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/(http[^\s]+)/g, "<a class='customAnchor' onClick=\"window.open('$1', '_self', 'location=no,toolbar=yes,enableViewPortScale=yes')\">$1</a>"));
            }

        }
    }
});
appServices.filter('createAnchors', function ($sce) {
    return function (str) {
        if (str != null && str != undefined) {
            return $sce.trustAsHtml(str.replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/(http[^\s]+)/g, '<a class="customAnchor" href="$1" target="_blank">$1</a>'));
        }

    }
});
appServices.filter('createAnchorsLight', function ($sce) {
    return function (str) {
        if (str != null && str != undefined) {
            return $sce.trustAsHtml(str.replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/(http[^\s]+)/g, '<a class="customAnchorLight" href="$1" target="_blank">$1</a>'));
        }

    }
});
appServices.filter('parseUrl', function () {
    var urls = /(\b(https?|ftp):\/\/[A-Z0-9+&@#\/%?=~_|!:,.;-]*[-A-Z0-9+&@#\/%=~_|])/gim
    var emails = /(\w+@[a-zA-Z_]+?\.[a-zA-Z]{2,6})/gim

    return function (text) {
        if (text.match(urls)) {
            text = text.replace(urls, "<a href=\"$1\" target=\"_blank\">$1</a>")
        }
        if (text.match(emails)) {
            text = text.replace(emails, "<a href=\"mailto:$1\">$1</a>")
        }

        return text
    }
})