/*Custom timeago.js created by Sijan Gurung
for Eventeye AS.....
2015*/
appServices.filter('timeago', function(){
  return function(date){
    return moment(moment(date).utc().format('YYYY-MM-DD HH:mm:ss')).fromNow();
      /* We can use this if we do not want any conditions... 
      for our purpose we want to show date if its 5 days old..so 
      using below....
      to use this filter simply use {{someDate | timeago}}*/
  };
});

appServices.directive('timeago', function() {
  return {
    restrict:'A',
    link: function(scope, element, attrs){
      attrs.$observe("timeago", function(){
          var now = moment.utc();
          //console.log("Current UTC Time is :"+moment.utc().format('YYYY-MM-DD HH:mm:ss'));
          var givenDate = attrs.timeago;
          
          //removing " from first and last..
          givenDate = moment(givenDate.replace(/"/g,"") );
          var difference = Math.floor ( (now - givenDate) / 86400000 ) ;
          //if 5 days old..send same date...
            if(difference <= 5){
                  element.text(moment(moment(givenDate).format('YYYY-MM-DD HH:mm:ss')).fromNow() );
            }else{ //format it into dd/mm/yyyy
                element.text(givenDate.format("DD.MM.YYYY"));
            }
      });
    }
  };
});

appServices.directive('backImg', function(){
    return function(scope, element, attrs){

        var url = attrs.backImg;
        element.css({
            'background-image': 'url(' + url +')',
            'background-size' : 'cover',
        });
    };
});
