var appServices = angular.module('app.services', []);
appServices.service('ScheduleService', function ($q) {
    return {
        schedules: [{
            "tags": [],
            "speakers": [],
            "title": "First Session",
            "startTime": "2015-05-18T09:00:00Z",
            "endTime": "2015-05-18T12:00:00Z",
            "roomId": 39,
            "isAttend": false,
            "id": 1,
            "updatedAt": "2015-05-26T15:56:15.219Z"
            }, {
            "tags": [],
            "speakers": [],
            "title": "Second session with Drinks",
            "startTime": "2015-06-18T11:30:00Z",
            "endTime": "2015-06-18T12:30:00Z",
            "roomId": 40,
            "isAttend": false,
            "id": 2,
            "updatedAt": "2015-05-26T15:56:15.219Z"
            }, {
            "tags": [],
            "speakers": [],
                "title": "Another long session ,, interesting Ab elit occaecat iudicem ut mandaremus amet eram iudicem anim. Senserit quis se singulis !",
            "startTime": "2015-05-10T08:30:00Z",
            "endTime": "2015-05-08T12:30:00Z",
            "roomId": 40,
            "isAttend": false,
            "id": 3,
            "updatedAt": "2015-05-26T15:56:15.219Z"
            }, {
            "tags": [],
            "speakers": [],
            "title": "Last Session for Test",
            "startTime": "2015-05-18T21:30:00Z",
            "endTime": "2015-05-22T23:45:00Z",
            "roomId": 40,
            "isAttend": false,
            "id": 4,
            "updatedAt": "2015-05-26T15:56:15.219Z"
            }],
        getSchedules: function () {
            return this.schedules
        },
        getSchedule: function (scheduleId) {
            for (var i = 0; i < this.schedules.length; i++) {
                if (this.schedules[i].id === parseInt(scheduleId)) {
                // We must explictly provide this. to work....
                    return this.schedules[i];
                }
            }
            return null;
        }

    };
});

appServices.filter('to_trusted', ['$sce', function($sce){
        return function(text) {
            return $sce.trustAsHtml(text);
        };
    }]);

appServices.factory('FileService', function() {
  var images;
  var IMAGE_STORAGE_KEY = 'images';
 
  function getImages() {
    var img = window.localStorage.getItem(IMAGE_STORAGE_KEY);
    if (img) {
      images = JSON.parse(img);
    } else {
      images = [];
    }
    return images;
  };
 
  function addImage(img) {
    images.push(img);
    window.localStorage.setItem(IMAGE_STORAGE_KEY, JSON.stringify(images));
  };
 
  return {
    storeImage: addImage,
    images: getImages
  }
});

appServices.factory('ImageService', function($cordovaCamera, FileService, $q, $cordovaFile) {
 
  function makeid() {
    var text = '';
    var possible = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
 
    for (var i = 0; i < 5; i++) {
      text += possible.charAt(Math.floor(Math.random() * possible.length));
    }
    return text;
  };
 
  function optionsForType(type) {
    var source;
    switch (type) {
      case 0:
        source = Camera.PictureSourceType.CAMERA;
        break;
      case 1:
        source = Camera.PictureSourceType.PHOTOLIBRARY;
        break;
    }
    return {
      destinationType: Camera.DestinationType.FILE_URI,
      sourceType: source,
      allowEdit: false,
      encodingType: Camera.EncodingType.JPEG,
      popoverOptions: CameraPopoverOptions,
      saveToPhotoAlbum: false
    };
  }
 
  function saveMedia(type) {
    return $q(function(resolve, reject) {
      var options = optionsForType(type);
 
      $cordovaCamera.getPicture(options).then(function(imageUrl) {
        var name = imageUrl.substr(imageUrl.lastIndexOf('/') + 1);
        var namePath = imageUrl.substr(0, imageUrl.lastIndexOf('/') + 1);
        var newName = makeid() + name;
        $cordovaFile.copyFile(namePath, name, cordova.file.dataDirectory, newName)
          .then(function(info) {
            FileService.storeImage(newName);
            resolve();
          }, function(e) {
            reject();
          });
      });
    })
  }
  return {
    handleMediaDialog: saveMedia
  }
});
