'use strict';

var app = angular.module('app');

app.factory('AppService', ['$window', '$http', 'appConstants', 'appConfiguration', '$log', function ($window, $http, appConstants, appConfiguration, $log) {

    var AppService = {

        hasConnection: function () {

            $log.debug("Polling Server to check for connection");

            var url = appConfiguration.apiUrlNoVersion + "check";
            $log.debug("URL: " + url);
            var promise = $http.get(url);
            promise.success(function (data, status) {
                $log.debug("Connection Check: " + data + " " + status);
                return;

            }).error(function (data, status) {
                $log.debug("Check Connection ERROR: " + data + " " + status);
                return;
            });
            return promise;
        }
    };

    return AppService;
}]);