var app = angular.module('app');

app.factory('CustomColorService', ['datacontext', 'ObjectService', 'eventService', 'appConstants', function (datacontext, ObjectService, eventService, appConstants) {

    var CustomColorService = {

        updateColorScheme: function () {
            
            // Request current colors from eventinfo
            var currentEvent = ObjectService.getSimpleObject(e.apiContentTypes.Event, datacontext.getCachedEventInformation(eventService.getId()));
            //console.log("colorservice");
            //console.log(currentEvent);

            // Remove existing style
            try {
                var sheetToBeRemoved = document.getElementById('customColorScheme');
                var sheetParent = sheetToBeRemoved.parentNode;
                sheetParent.removeChild(sheetToBeRemoved);
            } catch (e) {
                // Style not
            }            

            if (appConstants.app.isContainerApp) {
                var primaryColor = currentEvent.primaryColor;
                var primaryFontColor = currentEvent.primaryFontColor;
                var secondaryColor = currentEvent.secondaryColor;
                var secondaryFontColor = currentEvent.secondaryFontColor;
                var transparencyFactor = currentEvent.agendaTransparencyFactor;
            } else {
                
                var primaryColor = "#78BE20";
                var primaryFontColor = "#ffffff";
                var secondaryColor = primaryColor;
                var secondaryFontColor = primaryFontColor;
                var transparencyFactor = "1.0";
            }

            // sheet.innerHTML += ".PRIMARY { background-color: " + primaryColor + " !important; color: " + primaryFontColor + " !important;}";
            // sheet.innerHTML += ".SECONDARY { background-color: " + secondaryColor + " !important; color: " + secondaryFontColor + " !important;}";

            // Add new style
            var sheet = document.createElement('style')
            sheet.setAttribute("id", "customColorScheme");

            sheet.innerHTML += ".platform-ios .bar-stable { background-color: " + primaryColor + " !important; color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".platform-browser .bar-stable { background-color: " + primaryColor + " !important; color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".platform-android .bar-stable { background-color: " + primaryColor + " !important; color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".platform-ios .button-positive { color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".platform-browser .button-positive { color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".platform-android .button-positive { color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".platform-ios .header-item { color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".platform-browser .header-item { color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".platform-android .header-item { color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".platform-ios .button-clear { color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".platform-browser .button-clear { color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".platform-android .button-clear { color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".platform-ios .bar-clear { background-color: " + primaryColor + " !important; color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".platform-browser .bar-clear { background-color: " + primaryColor + " !important; color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".platform-android .bar-clear { background-color: " + primaryColor + " !important; color: " + primaryFontColor + " !important; }";

            sheet.innerHTML += ".listCard { border-top: " + primaryColor + " !important;}";
            sheet.innerHTML += ".feedFooter { background-color: " + primaryColor + " !important; }";
            sheet.innerHTML += ".cardSolidBackground { background-color: " + primaryColor + " !important;}";
            sheet.innerHTML += ".cardSolidBackground .textContainer { color: " + primaryFontColor + "}";
            sheet.innerHTML += ".postUpdateAttachmentButton { background-color: " + primaryColor + " !important; color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".modalBar { background-color: " + primaryColor + " !important;}";
            sheet.innerHTML += ".modalBar .title { color: " + primaryFontColor + "!important; }";
            sheet.innerHTML += ".modalBar .button { color: " + primaryFontColor + "!important; }";
            sheet.innerHTML += ".footerTrackFilter { background-color: rgba(" + hexToRgb(primaryColor).r + ", " +  hexToRgb(primaryColor).g + ", " + hexToRgb(primaryColor).b + ", 0.8) !important;}";
            sheet.innerHTML += ".rightFloating { background-color: " + primaryColor + " !important; color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".topPopUp { background: " + primaryColor + " !important;}";
            sheet.innerHTML += ".primaryColorBg { background-color: " + primaryColor + " !important;}";
            sheet.innerHTML += ".timeBoxContainer { background-color: " + primaryColor + " !important; background: linear-gradient(rgba(" + hexToRgb(primaryColor).r + ", " +  hexToRgb(primaryColor).g + ", " + hexToRgb(primaryColor).b + " ,1.0), rgba(" + hexToRgb(primaryColor).r + ", " +  hexToRgb(primaryColor).g + ", " + hexToRgb(primaryColor).b + ",0.97)) !important; }";
            sheet.innerHTML += ".timeBoxContainer .timeBox .startTime { color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".timeBoxContainer .timeBox .endTime { color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".timeBoxContainer .timeBox .star { color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".platform-android .agendaContent { margin-top: 90px !important; }";
            sheet.innerHTML += ".platform-android .agendaAndroidHeader { background-color: " + primaryColor + " !important; } ";
            sheet.innerHTML += ".platform-android .agendaAndroidHeader .dayLabel span { color: " + primaryFontColor + " !important; } ";
            sheet.innerHTML += ".platform-android .agendaAndroidHeader .tracksButton span { color: " + primaryFontColor + " !important; } ";
            sheet.innerHTML += ".agendaDatePickerContainer .leftLabel span {color: rgba(" + hexToRgb(primaryFontColor).r + ", " +  hexToRgb(primaryFontColor).g + ", " + hexToRgb(primaryFontColor).b + ", 0.9) !important; }";
            sheet.innerHTML += ".agendaDatePickerContainer .rightLabel span {color: rgba(" + hexToRgb(primaryFontColor).r + ", " +  hexToRgb(primaryFontColor).g + ", " + hexToRgb(primaryFontColor).b + ", 0.9) !important; }";
            sheet.innerHTML += ".agendaDatePickerContainer .centerLabel span {color: rgba(" + hexToRgb(primaryFontColor).r + ", " +  hexToRgb(primaryFontColor).g + ", " + hexToRgb(primaryFontColor).b + ", 1.0) !important; }";
            sheet.innerHTML += ".agendaDatePickerContainer .centerLabel .monthLabel {color: rgba(" + hexToRgb(primaryFontColor).r + ", " +  hexToRgb(primaryFontColor).g + ", " + hexToRgb(primaryFontColor).b + ", 1.0) !important; }";
            sheet.innerHTML += ".agendaModeSwitchContainer .left { color: rgba(" + hexToRgb(primaryFontColor).r + ", " +  hexToRgb(primaryFontColor).g + ", " + hexToRgb(primaryFontColor).b + ", 0.8) !important; }";
            sheet.innerHTML += ".agendaModeSwitchContainer .right { color: rgba(" + hexToRgb(primaryFontColor).r + ", " +  hexToRgb(primaryFontColor).g + ", " + hexToRgb(primaryFontColor).b + ", 0.8) !important; }";
            sheet.innerHTML += ".agendaModeSwitchContainer .active { color: " + primaryFontColor + " !important; }";

            sheet.innerHTML += ".agendaAcsStyle { background-color: " + primaryColor + " !important; }"
            sheet.innerHTML += ".agendaDetailsAcsStyle { background-color: " + primaryColor + " !important; margin-left: 0 !important; margin-right: 0 !important; height: 149px !important; }"

            sheet.innerHTML += ".profileTopDivSmall { background-color: " + primaryColor + " !important;}";
            sheet.innerHTML += ".profileTitleMedium { color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".notificationPopup .button { background-color: " + primaryColor + " !important; color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".notificationPopup .button.activated { background-color: " + primaryColor + " !important; }";
            sheet.innerHTML += ".primaryFontColor { color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".customFooter { background-color: " + primaryColor + " !important; color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".profile_picture { border: 1px solid rgba(" + hexToRgb(primaryColor).r + ", " + hexToRgb(primaryColor).g + ", " + hexToRgb(primaryColor).b + ", 0.5) !important; }"
            sheet.innerHTML += ".profileTitle { color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".profileIntro { color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".profileTopDiv { background-color: " + primaryColor + " !important;}";
            sheet.innerHTML += ".profileTopDivMedium { background-color: " + primaryColor + " !important;}";
            sheet.innerHTML += ".newProfileTopDiv { background-color: " + primaryColor + " !important;}";
            sheet.innerHTML += ".newProfileImageDiv { background: " + primaryColor + " !important;}";
            sheet.innerHTML += ".buttonSaveProfile { background-color: " + primaryColor + " !important; color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".buttonSaveProfile:hover { background-color: " + primaryColor + " !important; color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".buttonSaveProfileGray:hover { background-color: " + primaryColor + " !important; color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".footerSubmitButtonIcon { color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".notificationFeedContainer ion-item { background: " + primaryColor + " !important; color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".notificationFeedContainer contentText { color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".notificationFeedContainer { background: " + primaryColor + " !important; }";
            sheet.innerHTML += ".footerMoreOption { background: " + primaryColor + " !important; }";
            sheet.innerHTML += ".footerText h5 { color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".itemMenu i.leftIcon:before { color: " + primaryColor + " !important; }";
            sheet.innerHTML += ".menuProfile>img:first-child { border: 1px solid " + primaryColor + " !important; }";
            sheet.innerHTML += ".blackText { color: #000000 !important; }";
            sheet.innerHTML += ".answer { background: rgba(" + hexToRgb(primaryColor).r + ", " + hexToRgb(primaryColor).g + ", " + hexToRgb(primaryColor).b + ", 0.25) !important; }"
            sheet.innerHTML += ".answerValue { background-color: " + primaryColor + " !important; } ";
            sheet.innerHTML += ".custom-marker.myMarker { background-color: " + primaryColor + " !important; color: " + primaryFontColor + "!important; }";
            sheet.innerHTML += ".exhibitorProfileBG { background-color: " + primaryColor + " !important; } ";
            sheet.innerHTML += ".textColorPrimary * { color: " + primaryFontColor + " !important; } ";
            sheet.innerHTML += ".multiEventFooter { background: " + primaryColor + " !important; color: " + primaryFontColor + " !important;}";


            

            /*sheet.innerHTML += ".signinBtn { background-color: " + primaryColor + " !important; color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".signinBtn:hover { background-color: " + primaryColor + " !important; color: " + primaryFontColor + " !important;}";
            sheet.innerHTML += ".email_input { background-color: " + primaryColor + " !important; }";
            sheet.innerHTML += ".email_input input { color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".email_input ::-webkit-input-placeholder { color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".email_input :-moz-input-placeholder { color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".email_input ::-moz-input-placeholder { color: " + primaryFontColor + " !important; }";
            sheet.innerHTML += ".email_input :-ms-input-placeholder { color: " + primaryFontColor + " !important; }";*/


            // Trouble with this one since its :before (pseudo). https://stackoverflow.com/questions/29260296/modify-pseudo-select-after-in-javascript / or possibly ng-class?
            //sheet.innerHTML += ".agendaHeaderContainer:before { background-image: linear-gradient(rgba(" + hexToRgb(primaryColor).r + ", " +  hexToRgb(primaryColor).g + ", " + hexToRgb(primaryColor).b + ", " + transparencyFactor + "), rgba(" + hexToRgb(primaryColor).r + ", " +  hexToRgb(primaryColor).g + ", " + hexToRgb(primaryColor).b + ", " + transparencyFactor + ")), url(../img/agendaheaderbg_bw.jpg) !important;}"

            document.body.appendChild(sheet);

            //console.log("added styles");
    
        }
    };

    function hexToRgb(hex) {
        
        var shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])$/i;
        hex = hex.replace(shorthandRegex, function(m, r, g, b) {
            return r + r + g + g + b + b;
        });
    
        var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
        return result ? {
            r: parseInt(result[1], 16),
            g: parseInt(result[2], 16),
            b: parseInt(result[3], 16)
        } : null;
    }

    return CustomColorService;
}]);