'use strict';

var app = angular.module('app');


app.factory("eventService", ['$window', 'appConfiguration', '$log', function ($window, appConfiguration, $log) {

        var getCurrentEventString = function () {
            var currentEventString = $window.localStorage.getItem(appConfiguration.localStorageKeys.eventServiceKey);
            if (!currentEventString) {
                currentEventString = $window.sessionStorage.getItem(appConfiguration.localStorageKeys.eventServiceKey);
            }
            return currentEventString;
        };

        var getId = function () {
            var currentEventString = getCurrentEventString();            
            return currentEventString ? angular.fromJson(getCurrentEventString()).eventId : null;
        }


        var currentEvent = {
            create: function (currentEventId) {


                $window.localStorage.setItem(appConfiguration.localStorageKeys.eventServiceKey, angular.toJson({
                    eventId: currentEventId
                }));
            },
            destroy: function () {

                $window.localStorage.setItem(appConfiguration.localStorageKeys.eventServiceKey, angular.toJson({
                    eventId: null
                }));

            },


            getId: function () {
                return getId();
            },

        };

        return currentEvent;
}
]);