'use strict';

var app = angular.module('app');

app.factory('FlagContentService', ['$log', 'appConstants', '$cordovaEmailComposer', '$translate', 'PlatformCheck', '$window', 'eventService', function ($log, appConstants, $cordovaEmailComposer, $translate, PlatformCheck, $window, eventService) {

    var FlagContentService = {

        flagContent: function (contentType, contentId) {

            $translate.onReady().then(function () {
            
                var subject = "Inappropriate content report"
                var body = "<br /> <br /> ----------------<br />" + $translate.instant('GENERAL.FLAG_CONTENT.EMAIL_BODY_INFO_TEXT') + "<br /><br /> Content-type: " + contentType + " <br /> Identifier: " + eventService.getId() + "/" + contentId;
                var bodyText = "\n \n ----------------\n" + $translate.instant('GENERAL.FLAG_CONTENT.EMAIL_BODY_INFO_TEXT') + "\n \n Content-type: " + contentType + " \n Identifier: " + eventService.getId() + "/" + contentId;
                var newMail = {
                    to: appConstants.app.flagContentEmail,
                    subject: subject,
                    body: body,
                    bodyText: bodyText
                };


                if (PlatformCheck.isDevice()) {
                    $cordovaEmailComposer.open(newMail).then(null, function () {
                        // User cancelled email
                    });
                } else {
                    $window.location = ("mailto:" + newMail.to + "?subject=" + encodeURIComponent(newMail.subject) + "&body=" + encodeURIComponent(newMail.bodyText));
                }


                return;
            });
        }
    };



    return FlagContentService;
}]);