angular.module('ionic.ion.autoListDivider', [])

.directive('autoListDivider', function ($timeout) {
    var lastDivideKey = "";

    return {
        link: function (scope, element, attrs) {
            var key = attrs.autoListDividerValue;

            var dividers = document.getElementsByClassName("item-divider");

            var defaultDivideFunction = function (k) {
                return k.slice(0, 1).toUpperCase();
            }

            var doDivide = function () {
                var divideFunction = scope.$apply(attrs.autoListDividerFunction) || defaultDivideFunction;
                var divideKey = divideFunction(key);

                if (divideKey != lastDivideKey) {
                    var contentTr = angular.element("<div class='item item-divider customHeader'><i class='icon ion-ios-time-outline headerSideIcon'></i>" + divideKey + "</div>");
                    element[0].parentNode.insertBefore(contentTr[0], element[0]);
                }

                lastDivideKey = divideKey;
            }

            $timeout(doDivide, 0)
        }
    }

});